
/* Il faut placer cet include dans tous vos fichiers */
#include "../IpsDir/include/tel_oper.h"

/*****************************************************************************
 * Appel de cette fonction C dans tel_oper.c :
 *
 *	CO_BEGIN_EXE
 *	  double fois = CO_GET_REAL (1);
 *	  int    plus = CO_GET_INT  (2);
 *
 *	  ex1_affine (p->pix[1], p->pix[2], p->ysiz, p->xsiz, fois, plus);
 *	CO_END_EXE
 *
 * Les images 1 et 2 sont accedees par p->pix[1], p->pix[2].
 * Les images sont toutes en Unt16 (= unsigned short, 16 bits).
 *****************************************************************************/
void    ex1_affine (tab1, tab2, ysiz, xsiz, para1, para2)
Unt16  *tab1, *tab2;
int     ysiz, xsiz;
double  para1;
int     para2;
{
    int x, y, t, s;

    /* balayage de l'image */
    for (y = 0; y < ysiz; y++)
    for (x = 0; x < xsiz; x++) {

	/* On accede au point (x,y) de l'image 1 par tab1[y*xsiz+x]
	 * Si on accede plusieurs fois au meme point
	 * il vaut mieux calculer une seule fois l'offset t = y*xsiz+x
	 * et travailler sur tab1[t], tab2[t], etc.
	*/
	t = y * xsiz + x;
	s = (int) ( (double) tab1[t] * para1 ) + para2;

	/* On borne s dans [0,255] */
	tab2[t] = (s < 0) ? 0 : (s > 255) ? 255 : s;
    }
}
