/***************************************************************************************/
/* aide.c                                                     I.P.S  v 3.5  31/01/1995 */
/*                                                                                     */
/* Gestion de la boite d'aide                            Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#include "inclus.h"
 
#define LG_LIGNE	255+1
#define LG_MOT		255+1

static Frame  aideFrame;
static Textsw aideTextsw;
static int    aideAction = 0;

void aide_creer_frame ();
void aide_affi_oper ();
void aide_affi_tool ();
void aide_affi_text ();
void aide_affi ();
void aide_affi_edit ();
void aide_reaffi ();
void aide_action_proc ();
int  aide_get_action ();
void aide_nothing_to_do ();
void aide_affi_message ();
int  aide_text_not_lost ();
void aide_done_proc ();


/***************************************************************************************
 * Cree la fenetre d'aide et le menu menu_help
 *
 ***************************************************************************************/
void aide_creer_frame ()
{
    Panel panel;

    aideFrame = (Frame) xv_create (glo.frame_principal, FRAME_CMD,
	XV_X, 200,
	XV_Y, 200,
	FRAME_SHOW_RESIZE_CORNER, TRUE,
	FRAME_DONE_PROC, aide_done_proc,
	NULL);
 
    panel = (Panel) xv_get (aideFrame, FRAME_CMD_PANEL);

    (void) xv_create (panel, PANEL_CHOICE,
	PANEL_LABEL_STRING, "Menu action :",
	PANEL_CHOICE_STRINGS, AIDE_STRING_LIST, 0,
	PANEL_VALUE, 0,
	PANEL_NOTIFY_PROC, aide_action_proc,
	NULL);

    aideTextsw = (Textsw) xv_create (aideFrame, TEXTSW,
	XV_X, 0,
	XV_Y, 28,
	NULL);

    window_fit (aideTextsw);
    window_fit (aideFrame);
}


/***************************************************************************************
 * Affiche aide sur operateur
 *
 ***************************************************************************************/
void
aide_affi_oper (sujet)
char *sujet;
{
    char nom1[LG_LIGNE], nom2[LG_LIGNE], ligne[LG_LIGNE], cherche[LG_LIGNE];
    FILE *f1, *f2;
    int trouve, taille;

    /*
     * Ouverture des fichiers
    */
    sprintf (nom1, "%sips.oper_help", glo.chemin);
    sprintf (nom2, "%s/.ips_tmp_help", glo.home_dir);

    if ((f1 = fopen (nom1, "r")) == NULL) {
	pcp_error ("aide_affi_oper #01", "can't open the file", nom1, NULL);
	return;
    }
    if ((f2 = fopen (nom2, "w")) == NULL) {
	pcp_error ("aide_affi_oper #02", "can't create the file", nom2, NULL);
	fclose (f1);
	return;
    }

    /*
     * Recherche du texte dans fichier1
    */
    sprintf (cherche, "##(%s)", sujet);
    taille = strlen (cherche);
    trouve = FAUX;
    while ( fgets(ligne , LG_LIGNE , f1 ) != NULL ) 
    if (strncmp (ligne, cherche, taille) == 0) {
	trouve = VRAI;
	break; 
    }

    /*
     * Ecriture du texte dans fichier2
    */
    if (trouve) {
	while ( fgets(ligne , LG_LIGNE , f1 ) != NULL )
	if (strncmp (ligne, "##", 2) == 0)
	     break;
	else fputs (ligne, f2);
    } else {
	fprintf (f2, "\n\nNo help available for `%s'\n", sujet);
    }

    fclose (f2);
    fclose (f1);
    aide_affi ("Help on Operator", nom2);
}


/***************************************************************************************
 * Affiche texte
 *
 * L'appel : aide_affi_text (idf, fichier, "B_TEXT", "E_TEXT", "Help Window on", idf)
 *
 ***************************************************************************************/
void
aide_affi_text (sujet, nom1, debut, fin, leg1, leg2)
char *sujet, *nom1, *debut, *fin, *leg1, *leg2;
{
    char nom2[LG_LIGNE], ligne[LG_LIGNE], mot[LG_MOT], s_deb[LG_MOT], s_fin[LG_MOT],
	legende[LG_LIGNE];
    FILE *f1, *f2;
    int trouve;

    /*
     * Ouverture des fichiers
    */
    sprintf (nom2, "%s/.ips_tmp_help", glo.home_dir);

    if ((f1 = fopen (nom1, "r")) == NULL) {
	pcp_error ("aide_affi_text #01", "can't open the file", nom1, NULL);
	return;
    }
    if ((f2 = fopen (nom2, "w")) == NULL) {
	pcp_error ("aide_affi_text #02", "can't create the file", nom2, NULL);
	fclose (f1);
	return;
    }

    /*
     * Recherche du texte dans fichier1
    */
    sprintf (s_deb, " %s %%s", debut);
    sprintf (s_fin, " %s %%s", fin);
    trouve = FAUX;
    while ( fgets(ligne , LG_LIGNE , f1 ) != NULL ) 
    if ( sscanf (ligne, s_deb, mot) == 1 ) 
    if ( strcmp (mot, sujet) == 0) {
	trouve = VRAI;
	break; 
    }

    /*
     * Ecriture du texte dans fichier2
    */
    if (trouve) {
	while ( fgets(ligne , LG_LIGNE , f1 ) != NULL ) {
	    if ( sscanf (ligne, s_fin, mot) == 1 ) 
	    if ( strcmp (mot, sujet) == 0)
	         break;
	    fputs (ligne, f2);
	}
    } else {
	fprintf (f2, "\n\nNo text available for `%s'\n", sujet);
    }


    fclose (f2);
    fclose (f1);
    sprintf (legende, "%s%s", leg1, leg2);
    aide_affi (legende, nom2);
}


/***************************************************************************************
 * Affiche aide sur tool
 *
 ***************************************************************************************/
void
aide_affi_tool (sujet, nom1)
char *sujet, *nom1;
{
    char nom2[LG_LIGNE], ligne[LG_LIGNE];
    FILE *f2;

    /*
     * Test ouverture fichier
    */
    sprintf (nom2, "%s/.ips_tmp_help", glo.home_dir);
    if ((f2 = fopen (nom2, "w")) == NULL) {
	pcp_error ("aide_affi_tool #01", "can't create the file", nom2, NULL);
	return;
    }
    fclose (f2);

    /*
     * Appel du tool
    */
    sprintf (ligne, "%s -help >>  %s 2>> %s", nom1, nom2, nom2);
    system (ligne);

    aide_affi ("Help on Tool", nom2);
}


/***************************************************************************************
 * Re-affiche la fenetre
 *
 ***************************************************************************************/
void
aide_reaffi ()
{
    xv_set (aideFrame, FRAME_CMD_PUSHPIN_IN, TRUE, XV_SHOW, TRUE, NULL);
}

/***************************************************************************************
 * Affiche la fenetre d'aide
 *
 ***************************************************************************************/
void
aide_affi (nom_frame, nom_fich)
char *nom_frame, *nom_fich;
{
    Textsw_status status = TEXTSW_STATUS_OKAY;

    if (aide_text_not_lost ()) {

	xv_set (aideFrame, FRAME_LABEL, nom_frame, NULL);
	xv_set (aideTextsw,
	    TEXTSW_STATUS, &status,
	    TEXTSW_FILE, nom_fich,
	    TEXTSW_READ_ONLY, TRUE,
	    TEXTSW_BROWSING, TRUE,
	    TEXTSW_DISABLE_LOAD, TRUE,
	    TEXTSW_FIRST_LINE, 0,
	    NULL);
    }

    xv_set (aideFrame, 
	FRAME_CMD_PUSHPIN_IN, TRUE,
	XV_SHOW, (status == TEXTSW_STATUS_OKAY) ? TRUE : FALSE, 
	NULL);
}

/***************************************************************************************
 * Callback appele'e quand on de'punaise la fenetre
 *
 ***************************************************************************************/
void aide_done_proc ()
{
    int test = aide_text_not_lost () ? FALSE : TRUE;

    xv_set (aideFrame, FRAME_CMD_PUSHPIN_IN, test, XV_SHOW, test, NULL);
}

/***************************************************************************************
 * Affiche la fenetre d'aide en mode e'dition
 *
 ***************************************************************************************/
void
aide_affi_edit (nom_frame, nom_fich, num_ligne)
char *nom_frame, *nom_fich;
int num_ligne;
{
    Textsw_status status = TEXTSW_STATUS_OKAY;

    if (aide_text_not_lost ()) {

	xv_set (aideFrame, FRAME_LABEL, nom_frame, NULL);
	xv_set (aideTextsw,
	    TEXTSW_STATUS, &status,
	    TEXTSW_FILE, nom_fich,
	    TEXTSW_READ_ONLY, FALSE,
	    TEXTSW_BROWSING, FALSE,
	    TEXTSW_DISABLE_LOAD, FALSE,
	    TEXTSW_FIRST_LINE, num_ligne,
	    NULL);
    }

    xv_set (aideFrame, 
	FRAME_CMD_PUSHPIN_IN, TRUE,
	XV_SHOW, (status == TEXTSW_STATUS_OKAY) ? TRUE : FALSE, 
	NULL);
}


/***************************************************************************************
 * Callback du PANEL_CHOICE action
 *
 ***************************************************************************************/
void aide_action_proc (item, value, event)
Panel_item item;
int value;
Event *event;
{
    int test = (value > 0) || (value == 0 && aideAction == 0);
    aideAction = value;
    if (test) lmt_ClickNow ();
}

int aide_get_action ()
{ return aideAction; }

void aide_nothing_to_do ()
{ aide_affi_message ("Nothing to do - change \"Menu action\"."); }

/***************************************************************************************
 * Affichage d'un message dans la fenetre d'aide
 *
 ***************************************************************************************/
void aide_affi_message (message)
char *message;
{ 
    char nom2[LG_LIGNE];
    FILE *f2;

    sprintf (nom2, "%s/.ips_tmp_help", glo.home_dir);
    if ((f2 = fopen (nom2, "w")) == NULL) {
	pcp_error ("aide_affi_text #02", "can't create the file", nom2, NULL);
	fclose (f2);
	return;
    }
    fprintf (f2, "\n\n%s\n", message);
    fclose (f2);

    aide_affi ("Message", nom2);
}

/***************************************************************************************
 * Renvoie vrai si on peut changer de fichier sans perdre 1 texte modifie'.
 *
 ***************************************************************************************/
int aide_text_not_lost ()
{
    int result;

    if ((int) xv_get (aideTextsw, TEXTSW_MODIFIED) == 0) return VRAI;
    
    result = notice_prompt(glo.panel1, NULL,
	NOTICE_MESSAGE_STRINGS,  "The text has been edited.", NULL,
	NOTICE_BUTTON_YES,       "Cancel",
	NOTICE_BUTTON,           "Save now", 101,
	NOTICE_BUTTON,           "Discard edits", 102,
	NOTICE_NO_BEEPING,       TRUE,
	NULL);

    switch (result) {
	case NOTICE_YES :
	    return FAUX;
	case 101 :
	    textsw_save (aideTextsw, 0, 0);
	    return VRAI;
	case 102 :
	    textsw_reset (aideTextsw, 0, 0);
	    return VRAI;
    }
    return FAUX;
}


