/***************************************************************************************/
/* edi_princ.c                                                I.P.S  v 3.8b  12/2/1999  */
/*                                                                                     */
/* Editeur graphique                                     Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

/*
 * Initialisation du module dans main() :
 *   edi_loupe_init();
*/

#include "inclus.h"

static char loupe_car[11][7][5];

static int edi_undo_xsiz, edi_undo_ysiz;
static Unt16 *edi_undo_pic = (Unt16 *) NULL;  /* BUG 10.5.96 */

static Menu edi_menu_pane;


/****************************************************************************************
 * Initialisations generales
 *
 ***************************************************************************************/
void edi_init_generale ()
{
    /* La loupe */
    edi_loupe_init ();

    /* Menu contextuel */
    edi_menu_pane_init ();
}


/****************************************************************************************
 * Creation generale d'une edit window
 *
 ***************************************************************************************/

Edi *edi_create_win (int ordre, ...)
{
    /* Variables temporaires pour EDI_TOOLS */
    int		t_tools_exist = FAUX,
		t_tools_n = 0;
    char	*t_tools_title, *t_tools_v[100];

    /* Variables temporaires pour EDI_VAL_A */
    int		t_val_a_exist = FAUX,
		t_val_a_min, t_val_a_max, t_val_a_def;
    char	*t_val_a_title;

    /* Variables temporaires pour EDI_VAL_B */
    int		t_val_b_exist = FAUX,
		t_val_b_min, t_val_b_max, t_val_b_def;
    char	*t_val_b_title;

    /* Variables temporaires pour EDI_ACT_A */
    int		t_act_a_exist = FAUX,
		t_act_a_n = 0;
    char	*t_act_a_v[100];

    /* Variables temporaires pour EDI_ACT_B */
    int		t_act_b_exist = FAUX,
		t_act_b_n = 0;
    char	*t_act_b_v[100];

    /* Variables temporaires pour MESSA */
    int		ico_ind_v[8], ico_ind_n = 0;
 
   /* Variables diverses */
    va_list	ap;
    Edi		*edi;
    int		i, j, k, x, y;
    Ico		*ico;
    Image	*ima1, *ima2;
    Panel	panel;
    char	*t_name = NULL;
    Rect        *rect  = (Rect *) xv_get (
			xv_get(glo.panel1, CANVAS_NTH_PAINT_WINDOW,0), 
			WIN_MOUSE_XY );

    /*
     * Init Edi
    */
    if ((edi = (Edi *) pcp_alloc (sizeof(Edi))) == NULL) {
	va_end (ap);
	return;
    }
    pcp_footer ("Editing image ...", NULL);

    edi->ico1 =
    edi->ico2 = NULL;
    edi->tab1   = NULL;
    edi->tab2   = NULL;
    edi->coul_tab1 =
    edi->coul_tab2 = coul_bwc;

    /* + init xsiz1, .. ?? */

    edi->dedans = FAUX;
    edi->dead_refresh = VRAI;
    edi->cle_utilisation = EDI_CLE_UTILISATION;
    edi->zoom   = 1;
    edi->loupe  = 0;
    edi->act_cur = edi->act_a = edi->act_b = 0;
    edi->act_a_move = edi->act_b_move = -1;
    edi->rep.show = FAUX;

    edi->client_event_proc = NULL;
    edi->client_repaint_proc = NULL;
    edi->client_resize_proc = NULL;
    edi->client_done_proc = NULL;
    edi->client_tools_proc = NULL;

    edi->panel_slider_zoom =
    edi->panel_act_a =
    edi->panel_act_b =
    edi->panel_val_a =
    edi->panel_val_b = 0;

    /*
     * Lecture arguments
    */
    for (va_start (ap, ordre); ordre != 0; ordre = va_arg (ap, int))
    switch (ordre) {  

	case EDI_ICO_IMAGE :
	case EDI_ICO_2IMAGES :
	    ico = va_arg (ap, Ico *);
	    ima1 = ima2 = (Image *) ico->obj;
	    ico_ind_v[ico_ind_n++] = ico->index_creat;
	    edi->ico1 = edi->ico2 = ico;
	    if (t_name == NULL) t_name = ima1->ch1;

	    if (ordre == EDI_ICO_2IMAGES) {
		ico = va_arg (ap, Ico *);
		if (ico != NULL) {
		    ima2 = (Image *) ico->obj;
		    ico_ind_v[ico_ind_n++] = ico->index_creat;
		    edi->ico2 = ico;
		}
	    }
	    edi->tab1      = ima1->tab;
	    edi->coul_tab1 = ima1->coul_tab;
	    edi->cmin1  = ima1->b.cmin;
	    edi->xsiz1  = ima1->b.xsiz;
	    edi->ysiz1  = ima1->b.ysiz;
	    edi->xtot1  = ima1->b.xtot;

	    edi->tab2      = ima2->tab;
	    edi->coul_tab2 = ima2->coul_tab;
	    edi->cmin2  = ima2->b.cmin;
	    edi->xsiz2  = ima2->b.xsiz;
	    edi->ysiz2  = ima2->b.ysiz;
	    edi->xtot2  = ima2->b.xtot;
	    break;
	case EDI_ICO_CLIENTS : {
	    Ico *cur;
	    while ((cur = va_arg (ap, Ico *)) != NULL) {
		ico_ind_v[ico_ind_n++] = cur->index_creat;
	    }
	} break;
	case EDI_TOOLS :
	    t_tools_exist = VRAI;
	    t_tools_title = va_arg (ap, char *);
	    edi->client_tools_proc = va_arg (ap, void *);
	    while ((t_tools_v[t_tools_n] = va_arg (ap, char *)) != NULL) t_tools_n++;
	    break;
	case EDI_VAL_A :
	    t_val_a_exist = VRAI;
	    t_val_a_title = va_arg (ap, char *);
	    t_val_a_min   = va_arg (ap, int);
	    t_val_a_max   = va_arg (ap, int);
	    t_val_a_def   = va_arg (ap, int);
	    break;
	case EDI_VAL_B :
	    t_val_b_exist = VRAI;
	    t_val_b_title = va_arg (ap, char *);
	    t_val_b_min   = va_arg (ap, int);
	    t_val_b_max   = va_arg (ap, int);
	    t_val_b_def   = va_arg (ap, int);
	    break;
	case EDI_ACT_A :
	    t_act_a_exist = VRAI;
	    edi->act_a_move  = va_arg (ap, int);
	    while ((t_act_a_v[t_act_a_n] = va_arg (ap, char *)) != NULL) t_act_a_n++;
	    break;
	case EDI_ACT_B :
	    t_act_b_exist = VRAI;
	    edi->act_b_move  = va_arg (ap, int);
	    while ((t_act_b_v[t_act_b_n] = va_arg (ap, char *)) != NULL) t_act_b_n++;
	    break;

	case EDI_EVENT_PROC :
	    edi->client_event_proc = va_arg (ap, void *);
	    break;
	case EDI_REPAINT_PROC :
	    edi->client_repaint_proc = va_arg (ap, void *);
	    break;
	case EDI_RESIZE_PROC :
	    edi->client_resize_proc = va_arg (ap, void *);
	    break;
	case EDI_DONE_PROC :
	    edi->client_done_proc = va_arg (ap, void *);
	    break;
	case EDI_CLIENT_DATA :
	    i = va_arg (ap, int);
	    edi->client_data[i] = va_arg (ap, void *);
	    break;
	case EDI_NAME :
	    t_name = va_arg (ap, char *);
	    break;
	case EDI_DEAD_REFRESH :
	    edi->dead_refresh = va_arg (ap, int);
	    break;
    }

    /*
     * Fin lecture args
    */
    va_end (ap);

    /*
     * A ce niveau, edi->xsiz1 et edi->ysiz1 sont definis --> init edi->bx_
    */
    edi->bxmin  = 0;
    edi->bymin  = 0;
    edi->bxmax  = edi->xsiz1;
    edi->bymax  = edi->ysiz1;
    edi->bxdif  = edi->bxmax - edi->bxmin;
    edi->bydif  = edi->bymax - edi->bymin;

    /*
     * On signale le nouveau client a la messagerie
    */
    edi->messa_index = messa_NewClient (edi_messaProc, edi, ico_ind_v, ico_ind_n);
    
    /*
     * Choix taille fenetre en fct taille image
    */
    k =  1; /* 512 / (edi->xsiz1 + 1) + 1; */
    x = edi->xsiz1 * k;
    y = edi->ysiz1 * k;
    if (x > glo.scr_xm-20) x = glo.scr_xm-20;
    if (y > glo.scr_ym-40) y = glo.scr_ym-40;

    rep_init(edi);

   /*
     * Creation fenetre edition
    */
    edi->frame = (Frame) xv_create (glo.frame_principal, FRAME_CMD,
	XV_WIDTH, x+2,
	XV_HEIGHT,y+2, 
	XV_X, rect->r_left,
	XV_Y, rect->r_top,
	FRAME_SHOW_RESIZE_CORNER, TRUE,
	FRAME_DONE_PROC, edi_done_proc,
	WIN_CLIENT_DATA, edi,
	0);

    edi->canvas = (Canvas) xv_create (edi->frame, CANVAS,
	WIN_CMS, cms_palette,
	XV_Y, 0,
	CANVAS_AUTO_SHRINK, TRUE,
	CANVAS_AUTO_EXPAND, TRUE,
	CANVAS_X_PAINT_WINDOW, TRUE,
	CANVAS_REPAINT_PROC, edi_repaint, 
	CANVAS_RESIZE_PROC, edi_resize,
	CANVAS_FIXED_IMAGE, FALSE, /* force l'appel de repaint a chaque resizement */
	WIN_CLIENT_DATA, edi,
	0);

    xv_set (canvas_paint_window(edi->canvas),
	WIN_EVENT_PROC, edi_event_proc,
	WIN_CLIENT_DATA, edi,
	WIN_CONSUME_EVENTS,
	    WIN_MOUSE_BUTTONS, LOC_DRAG, LOC_MOVE, LOC_WINEXIT, 0,
	0);

    edi_resize (edi->canvas, x, y);  /* initialisation pour xview V3 */

    /*
     * Creation repere
    */
    edi->rep.frame = (Frame) xv_create (glo.frame_principal, FRAME_CMD,
	FRAME_SHOW_RESIZE_CORNER, FALSE,
	FRAME_CMD_PUSHPIN_IN, TRUE,
	FRAME_DONE_PROC, rep_cacher_frame,
	WIN_CLIENT_DATA, edi,
	FRAME_SHOW_FOOTER, TRUE,
	0);

    /* maintenant on peut donner un nom a edi->frame et edi->rep.frame */
    edi_maj_nom (edi, (t_name != NULL) ? t_name : "No name",  
	edi->ico1->index_creat,  edi->ico2->index_creat);

    panel = (Panel) xv_get (edi->rep.frame, FRAME_CMD_PANEL);
    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, 0);

    edi->panel_slider_zoom = (Panel_item) xv_create (panel, PANEL_SLIDER,
	XV_Y, 10,
	PANEL_LABEL_STRING, "Zoom",
	PANEL_VALUE, 1,
	PANEL_MIN_VALUE, 1,
	PANEL_MAX_VALUE, 20,
	PANEL_SLIDER_WIDTH, 70,
	PANEL_NOTIFY_PROC, edi_slider_zoom_proc,
	PANEL_CLIENT_DATA, edi,
	0);

    /* Menu Vision */

    edi->menu_vision = (Menu) xv_create (0, MENU, 
	    MENU_STRINGS, "Refresh", "magnify V1 C2","magnify V2 C1",
		"16 colors","256 grey levels", "16 colors + grey", "change selection", 0,
	    0);
    xv_set (edi->menu_vision,
	MENU_NOTIFY_PROC, edi_choix_vision,
	MENU_CLIENT_DATA, edi,
	0);
    (void) xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING, "Vision",
	PANEL_ITEM_MENU, edi->menu_vision,
	0);

    /* Menu Size */

    edi->menu_size = (Menu) xv_create (0, MENU, 
	MENU_STRINGS, "whole", "2 times","3 times","zoom", "win 512","win 768", 0,
	MENU_NOTIFY_PROC, edi_choix_taille,
	MENU_CLIENT_DATA, edi,
	0);
    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, 0);
    (void) xv_create (panel, PANEL_BUTTON,
	PANEL_LABEL_STRING, "Size",
	PANEL_ITEM_MENU, edi->menu_size,
	0);

    /* Creation EDI_TOOLS */

    if (t_tools_exist) {
	edi->menu_outil = (Menu) xv_create (0, MENU,
	    MENU_GEN_PIN_WINDOW, edi->frame, t_tools_title,
	    MENU_NOTIFY_PROC, edi_choix_tools,
	    MENU_CLIENT_DATA, edi,
	    0);
	for (i = 0; i < t_tools_n; i++) {
	    char *nom = (char *) malloc (strlen (t_tools_v[i])+1);
	    strcpy (nom, t_tools_v[i]);
	    xv_set (edi->menu_outil, MENU_APPEND_ITEM,
		(Menu_item) xv_create (0, MENUITEM,
		MENU_STRING, nom,
		MENU_RELEASE,
		0),
	    0);
	}
	(void) xv_create (panel, PANEL_BUTTON,
	    PANEL_LABEL_STRING, t_tools_title,
	    PANEL_ITEM_MENU, edi->menu_outil,
	    0);
    }

    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, 0);

    /* Creation EDI_VAL_A */

    if (t_val_a_exist)
	edi->panel_val_a = (Panel_item) xv_create (panel, PANEL_NUMERIC_TEXT,
	    PANEL_LABEL_STRING,         t_val_a_title,
	    PANEL_MIN_VALUE,            t_val_a_min,
	    PANEL_MAX_VALUE,            t_val_a_max,
	    PANEL_VALUE_DISPLAY_LENGTH, 5,
	    PANEL_VALUE,                t_val_a_def,
	    0);

    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, 0);

    /* Creation EDI_VAL_B */

    if (t_val_b_exist)
	edi->panel_val_b = (Panel_item) xv_create (panel, PANEL_NUMERIC_TEXT,
	    PANEL_LABEL_STRING,         t_val_b_title,
	    PANEL_MIN_VALUE,            t_val_b_min,
	    PANEL_MAX_VALUE,            t_val_b_max,
	    PANEL_VALUE_DISPLAY_LENGTH, 5,
	    PANEL_VALUE,                t_val_b_def,
	    0);

    xv_set (panel, PANEL_LAYOUT, PANEL_VERTICAL, 0);

    /* Creation EDI_ACT_A */

    if (t_act_a_exist) {
	edi->panel_act_a = (Panel_item) xv_create (panel, PANEL_CHOICE_STACK,
	    PANEL_NOTIFY_PROC, edi_choix_act,  
	    PANEL_VALUE, 0,
	    PANEL_CLIENT_DATA, edi,
	    0);
	for (i = 0; i < t_act_a_n; i++)
	    xv_set (edi->panel_act_a, PANEL_CHOICE_STRING, i, t_act_a_v[i], 0);
    }

    xv_set (panel, PANEL_LAYOUT, PANEL_HORIZONTAL, 0);

    /* Creation EDI_ACT_B */

    if (t_act_b_exist) {
	edi->panel_act_b = (Panel_item) xv_create (panel, PANEL_CHOICE_STACK,
	    PANEL_NOTIFY_PROC, edi_choix_act,  
	    PANEL_VALUE, 0,
	    PANEL_CLIENT_DATA, edi,
	    0);
	for (i = 0; i < t_act_b_n; i++)
	    xv_set (edi->panel_act_b, PANEL_CHOICE_STRING, i, t_act_b_v[i], 0);
	if (t_val_b_exist)
	    xv_set (edi->panel_act_b,
		XV_X, (int) xv_get (edi->panel_val_b, XV_X),
	    0);
    }

    /* ajustement du panel */
    window_fit (panel);

    /* Canvas repere */

    edi->rep.canvas = (Canvas) xv_create (edi->rep.frame, CANVAS,
	WIN_CMS, cms_palette,
	XV_X, ((int) xv_get (panel, XV_WIDTH) - edi->rep.xm+2) /2,
	XV_Y, (int) xv_get (panel, XV_HEIGHT),
	XV_WIDTH, edi->rep.xm+2,
	XV_HEIGHT,edi->rep.ym+2,
	CANVAS_X_PAINT_WINDOW, TRUE,
	CANVAS_REPAINT_PROC, rep_repaint, 
	WIN_CLIENT_DATA, edi,
	0);

    xv_set (canvas_paint_window(edi->rep.canvas),
	WIN_EVENT_PROC, rep_event_proc,
	WIN_CLIENT_DATA, edi,
	WIN_CONSUME_EVENTS,
	    WIN_MOUSE_BUTTONS, LOC_MOVE, LOC_WINEXIT, 0,
	0);

    /* ajustement de la fenetre */
    xv_set (panel, XV_HEIGHT,
	(int) xv_get (panel, XV_HEIGHT) +  
	(int) xv_get (edi->rep.canvas, XV_HEIGHT), 
	0);
    window_fit (edi->rep.frame);

    /* Parametres graphiques X11 */

    edi->p_win  = (Xv_Window) xv_get (edi->canvas, CANVAS_NTH_PAINT_WINDOW, 0);
    edi->dpy    = (Display*)  xv_get (edi->p_win, XV_DISPLAY);
    edi->xwin   = (Window)    xv_get (edi->p_win, XV_XID);
    edi->screen = DefaultScreen (edi->dpy);
    edi->gc     = DefaultGC     (edi->dpy, edi->screen);
    edi->depth  = DefaultDepth  (edi->dpy, edi->screen);
    edi->visual = DefaultVisual (edi->dpy, edi->screen);

    edi->rep.p_win  = (Xv_Window) xv_get (edi->rep.canvas, CANVAS_NTH_PAINT_WINDOW, 0);
    edi->rep.dpy    = (Display*)  xv_get (edi->rep.p_win, XV_DISPLAY);
    edi->rep.xwin   = (Window)    xv_get (edi->rep.p_win, XV_XID);
    edi->rep.screen = DefaultScreen (edi->rep.dpy);
    edi->rep.gc     = DefaultGC     (edi->rep.dpy, edi->rep.screen);
    edi->rep.depth  = DefaultDepth  (edi->rep.dpy, edi->rep.screen);
    edi->rep.visual = DefaultVisual (edi->rep.dpy, edi->rep.screen);

    /* Tout est ok, on affiche la fenetre */
    xv_set (edi->frame, XV_SHOW, TRUE, FRAME_CMD_PUSHPIN_IN, TRUE, 0);
    pcp_footer_n ();
    return edi;
}


/****************************************************************************************
 * appele par FRAME_DONE_PROC
 *
 ***************************************************************************************/
 
void edi_done_proc (frame)
Frame frame;
{
    Edi *edi = (Edi *) xv_get (frame, WIN_CLIENT_DATA);

#   ifdef DEBUG
    printf("edi_done_proc %s\n", (char *) xv_get (frame, FRAME_LABEL));
#   endif

    /* Propage le message done, qui provoque un refresh general */
    if (edi->dead_refresh) messa_Send (
	MESSA_FROM_WIN_ID, edi->messa_index, 
	MESSA_TO_ICO, edi->ico1, 
	MESSA_DONE, VRAI,
	0);
    edi_tuer_edi (edi, EDI_DONE_BY_MOUSE);
}


/****************************************************************************************
 * destruction d'une fenetre editeur
 *
 ***************************************************************************************/

void edi_tuer_edi (edi, reason)
Edi *edi;
int reason;
{
    if (edi->client_done_proc != NULL)
	(*edi->client_done_proc)(edi, reason);

    if (xv_destroy_safe(edi->rep.frame) != XV_OK)
	pcp_error ("edi_tuer_edi #01", NULL);

    if (xv_destroy_safe(edi->frame) != XV_OK)
	pcp_error ("edi_tuer_edi #02", NULL);

    messa_DeleteClient (edi->messa_index);

    /* On libere edi_undo_pic systematiquement */
    if (edi_undo_pic != (Unt16 *) NULL) free (edi_undo_pic);
    edi_undo_pic = (Unt16 *) NULL;

    /* Protection face aux appels posterieurs malencontreux de edi_repaint(), etc */
    edi->cle_utilisation = 0;

    pcp_free(edi);
}


/****************************************************************************************
 * initialisation des caracteres de la loupe : a appeler une seule fois dans main()
 *
 ***************************************************************************************/

void edi_loupe_init ()
{
  int  code[14];
  char zone[7][61];
  int  x, y, i, j, n;

  code[ 0] = 0x1C477C5;  code[ 7] = 0xF37DCE0;
  code[ 1] = 0x22C888D;  code[ 8] = 0x0406310;
  code[ 2] = 0x2640915;  code[ 9] = 0xE80A310;
  code[ 3] = 0x2A410A4;  code[10] = 0x1F11CF0;
  code[ 4] = 0x324207E;  code[11] = 0x1892210;
  code[ 5] = 0x2244445;  code[12] = 0x1892220;
  code[ 6] = 0x1CEFB84;  code[13] = 0xE711CC0;

  /* dessin des chiffres */
  for (i = 0; i < 7; i++) for (j = 0; j < 61; j++) zone[i][j] = 0;
  for (i = 0; i <= 13; i++) for (j = 27; j >= 0; j--)
  {
    x = 27 -j +28*(i/7);
    y = i % 7;
    zone[y][x] = (code[i] >> j) & 1;
  }

  /* mise en memoire */
  for (n = 0; n <= 10; n++)
  for (y = 0; y < 7; y++) for (x = 0; x < 5; x++)
  loupe_car[n][y][x] = zone[y][2+n*5+x];

  /* affichage de controle */
#ifdef DEBUG
   for (n = 0; n <= 10; n++)
     { printf("caractere %d\n",n);
       for (y = 0; y < 7; y++) 
       { for (x = 0; x < 5; x++) 
         if (loupe_car[n][y][x] == 1) 
         printf("1"); else printf(" "); printf("\n"); }
     }
#endif
}


/****************************************************************************************
 * dessin du quadrillage de la loupe
 *
 ***************************************************************************************/

void edi_loupe_quadri (edi)
Edi *edi;
{
  int a;

#ifdef DEBUG
  printf("edi_loupe_quadri\n");
#endif
/*
  XSetForeground (edi->dpy, edi->gc, coul_bwc[255]);
  XFillRectangle (edi->dpy, edi->xwin, edi->gc, 0, 0, edi->exdif, edi->eydif);
*/
  XSetForeground (edi->dpy, edi->gc, coul_bwc[7]);
  for (a = 0; a <= edi->bydif; a++)
  XDrawLine (edi->dpy, edi->xwin, edi->gc, 0, a*20, edi->cxdif, a*20);
  for (a = 0; a <= edi->bxdif; a++)
  XDrawLine (edi->dpy, edi->xwin, edi->gc, a*20, 0, a*20, edi->cydif);
}


/****************************************************************************************
 * dessin d'une case de la loupe
 *
 ***************************************************************************************/

void edi_loupe_case (edi, xc, yc, t, c)
Edi     *edi;
int      xc, yc, t;
Unt32     c;
{
  int  xp, yp, i, x, y, v;
  char hatch[6];

  /* separation des chiffres de t */
  i = 5; v = t;
  while (v != 0)
  {
    hatch[i] = v % 10;
    v        = v / 10;
    i -= 1;
  }
  while (i >= 1)
  {
    hatch[i] = 10;
    i -= 1;
  }

  /* affichage val_cur de c */
  XSetForeground (edi->dpy, edi->gc, coul_bwc[255]);
  XFillRectangle (edi->dpy, edi->xwin, edi->gc, xc+1, yc+1, 19, 19);
  XSetForeground (edi->dpy, edi->gc, c);
  XFillRectangle (edi->dpy, edi->xwin, edi->gc, xc+1, yc+1, 6, 8);

  /* affichage des chiffres de t */
  XSetForeground (edi->dpy, edi->gc, coul_bwc[0]);
  for (i = 1; i <= 5; i++)
  {
    xp = xc + 6*(i % 3) + 2;
    yp = yc + 8*(i / 3) + 3;
    for (y = 0; y < 7; y++) for (x = 0; x < 5; x ++)
    if (loupe_car[hatch[i]][y][x])
    XDrawPoint (edi->dpy, edi->xwin, edi->gc, xp+x, yp+y);
  } 
}


/****************************************************************************************
 * Affichage en police "loupe" du chiffre v >= 0 en noir sur fond blanc.
 * 
 * Utilise' dans fig_decode_dessins()
 ***************************************************************************************/

void edi_loupe_label (edi, xc, yc, v)
Edi     *edi;
int      xc, yc, v;
{
    int  i, x, y, n;
    char hatch[16];

    /* separation des chiffres de v */
    n = 0;
    do { hatch[n] = v % 10; v = v / 10; n++; } while (v > 0);

    /* affichage fond noir */
    XSetForeground (edi->dpy, edi->gc, coul_bwc[255]);
    XFillRectangle (edi->dpy, edi->xwin, edi->gc, xc-1, yc-1, 1+n*6, 9);

    /* affichage des chiffres de v */
    XSetForeground (edi->dpy, edi->gc, coul_bwc[0]);
    for (i = n-1; i >= 0; i--) {
	for (y = 0; y < 7; y++) for (x = 0; x < 5; x++)
	    if (loupe_car[hatch[i]][y][x])
		XDrawPoint (edi->dpy, edi->xwin, edi->gc, xc+x, yc+y);
	xc += 6;
    } 
}

/****************************************************************************************
 * dessin d'un point zoom*zoom ou en mode loupe
 *
 ***************************************************************************************/

void edi_dessin_point (edi, x, y, v1)
Edi     *edi;
int      x, y, v1;          /* coord tab sans decalage, valeur dans tab1 */
{
  int xc = x * edi->zoom;   /* coord ecran             */
  int yc = y * edi->zoom;
  int xd = x + edi->bxmin;  /* coord tab avec decalage */
  int yd = y + edi->bymin;

  switch (edi->loupe)
  {
    case 0 :  /* normal */
        XSetForeground (edi->dpy, edi->gc, edi->coul_tab1[1+(v1-1)%255]);
        XFillRectangle (edi->dpy, edi->xwin, edi->gc, xc, yc, edi->zoom, edi->zoom);
        break;

    case 1 : { /* loupe 1 */
        int v2 = (edi->tab2 != NULL && xd < edi->xsiz2 && yd < edi->ysiz2)
            ? edi->tab2[ xd + edi->cmin2 + (yd + edi->cmin2)*edi->xtot2 ] : 0;
        edi_loupe_case (edi, xc, yc, v1, edi->coul_tab2[1+(v2-1)%255]);
        } break;

    case 2 : { /* loupe 2 */
        int v2 = (edi->tab2 != NULL && xd < edi->xsiz2 && yd < edi->ysiz2)
            ? edi->tab2[ xd + edi->cmin2 + (yd + edi->cmin2)*edi->xtot2 ] : 0;
        edi_loupe_case (edi, xc, yc, v2, edi->coul_tab1[1+(v1-1)%255]);
        } break;
  }
}


/****************************************************************************************
 * mettre une image dans un vecteur pour affichage
 *
 ***************************************************************************************/

void edi_vecteur_ecran (pt, zoom, step, x1, y1, nx, ny, c_tot, tab, coul_tab)

char  *pt;        /* pointe sur char[nx*ny*zoom*zoom]                   */
int    zoom;      /* facteur de grossissement dans *pt                  */
int    step;      /* increment dans pic                                 */
int    x1, y1;    /* coin superieur gauche dans pic                     */
int    nx, ny;    /* nx*ny points dans pic ; nx*zoom*ny*zoom dans *pt   */
int    c_tot;     /* taille d'une ligne dans tab                        */
Unt16 *tab;       /* tab[y*c_tot+x]                                     */
Unt32  *coul_tab; /* table des val_curs a employer                      */

{
  int x, y, x2, y2;                  /* dans tab   */
  int p1, p2, p1m, p2m, k1, k2, k3;  /* dans *pt   */
  int c;                             /* val_cur    */

  x2 = x1 + nx*step;   /* dans tab   */
  y2 = y1 + ny*step;
  p1 = 0;              /* dans *pt   */

  if (zoom == 1)
         for (y = y1; y < y2; y += step)
         for (x = x1; x < x2; x += step)
           {
             *(pt +p1) = coul_tab[1+(tab[y*c_tot+x]-1)%255];
             p1 += 1;
           }
  else {
         k1 = nx*zoom;
         k2 = k1*zoom;
         k3 = k2 - k1;

         for (y = y1; y < y2; y += step)
           {
             for (x = x1; x < x2; x += step)
               {
                 c = coul_tab[1+(tab[y*c_tot+x]-1)%255];

                 p1m = p1 + zoom;
                 do
                   {
                     p2m = p1 + k2;
                     for (p2 = p1; p2 < p2m; p2 += k1)
                     *(pt +p2) = c;
                     p1 += 1;
                   }
                 while (p1 < p1m);
               } /* for x */
             p1 += k3;
           } /* for y */
       } /* else */
}


void edi_vecteur_ecran_RGB (ptR, ptG, ptB, zoom, step, x1, y1, nx, ny, c_tot, tab, 
	colR, colG, colB)

char  *ptR, *ptG, *ptB;    /* pointe sur char[nx*ny*zoom*zoom]                   */
int    zoom;               /* facteur de grossissement dans *pt                  */
int    step;               /* increment dans pic                                 */
int    x1, y1;             /* coin superieur gauche dans pic                     */
int    nx, ny;             /* nx*ny points dans pic ; nx*zoom*ny*zoom dans *pt   */
int    c_tot;              /* taille d'une ligne dans tab                        */
Unt16 *tab;                /* tab[y*c_tot+x]                                     */
Unt8  *colR, *colG, *colB; /* table des couleurs a employer                      */

{
  int x, y, x2, y2, t, p1, p2, p1m, p2m, k1, k2, k3; 

  x2 = x1 + nx*step;   /* dans tab   */
  y2 = y1 + ny*step;
  p1 = 0;              /* dans *pt   */

  if (zoom == 1)
         for (y = y1; y < y2; y += step)
         for (x = x1; x < x2; x += step)
           {
             t = 1+(tab[y*c_tot+x]-1)%255;
             ptR[p1] = colR[t]; ptG[p1] = colG[t]; ptB[p1] = colB[t];
             p1 += 1;
           }
  else {
         k1 = nx*zoom;
         k2 = k1*zoom;
         k3 = k2 - k1;

         for (y = y1; y < y2; y += step)
           {
             for (x = x1; x < x2; x += step)
               {
                 t = 1+(tab[y*c_tot+x]-1)%255;

                 p1m = p1 + zoom;
                 do
                   {
                     p2m = p1 + k2;
                     for (p2 = p1; p2 < p2m; p2 += k1) {
			ptR[p2] = colR[t]; ptG[p2] = colG[t]; ptB[p2] = colB[t];
                     }
                     p1 += 1;
                   }
                 while (p1 < p1m);
               } /* for x */
             p1 += k3;
           } /* for y */
       } /* else */
}

/****************************************************************************************
 * affichage dans une fenetre editeur
 *
 ***************************************************************************************/

void edi_repaint (canvas, p_win, dpy, xwin, area)
Canvas       canvas;
Xv_Window    p_win;
Display      *dpy;
Window       xwin;
Xv_xrectlist *area;

{
  Edi     *edi    = (Edi*) xv_get (canvas, WIN_CLIENT_DATA);
  int      taille = edi->bxdif * edi->bydif * edi->zoom * edi->zoom;
  XImage  *xi;
  int      x, y, yp;

#ifdef DEBUG
  printf("edi_repaint (cle = %d)\n", edi->cle_utilisation);
#endif

  /* Protection */
  if (edi->cle_utilisation != EDI_CLE_UTILISATION) return;

  if (edi->loupe || edi->depth < 8)  /* mode loupe ou < 8 plans */
  {
    if (edi->loupe) edi_loupe_quadri (edi);

    if (edi->tab1 == NULL)
      for (y = 0; y < edi->bydif; y++)
      for (x = 0; x < edi->bxdif; x++)
      edi_dessin_point (edi, x, y, 0);
    else
      for (y = 0; y < edi->bydif; y++)
      for (x = 0; x < edi->bxdif; x++)
      edi_dessin_point (edi, x, y, (int) edi->tab1[
	 x+edi->cmin1+edi->bxmin +
	(y+edi->cmin1+edi->bymin)*edi->xtot1 ]);
  }
  else if (edi->depth == 8)  /* mode 8 plans */
  {
    char *data;
    
    if ((data = (char*) calloc (taille, sizeof(char))) != NULL)
    {
      if (edi->tab1 != NULL)
        edi_vecteur_ecran ( data, edi->zoom, 1, edi->bxmin+edi->cmin1, edi->bymin+edi->cmin1, 
          edi->bxdif, edi->bydif, edi->xtot1, edi->tab1, edi->coul_tab1);

      xi = XCreateImage (dpy, edi->visual, edi->depth, ZPixmap, 0, data, edi->cxdif, edi->cydif, 8, 0);

      XPutImage (dpy, xwin, edi->gc, xi, 0, 0, 0, 0, edi->cxdif, edi->cydif);

      XDestroyImage (xi);  /* libere aussi data */
    }
    else pcp_error ("edi_repaint #1", "malloc error", NULL);
  }
  else /* mode RGB */
  {
    char *dataR = NULL, *dataG = NULL, *dataB = NULL;
    if ( (dataR = (char*) calloc (taille, sizeof(char))) == NULL ||
         (dataG = (char*) calloc (taille, sizeof(char))) == NULL ||
         (dataB = (char*) calloc (taille, sizeof(char))) == NULL )
    pcp_error ("edi_repaint #2", "malloc error", NULL);
    else {
      if (edi->tab1 != NULL)
        edi_vecteur_ecran_RGB ( dataR, dataG, dataB,
        	edi->zoom, 1, edi->bxmin+edi->cmin1, edi->bymin+edi->cmin1, 
		edi->bxdif, edi->bydif, edi->xtot1, edi->tab1, 
                glo_get_colR(edi->coul_tab1),
                glo_get_colG(edi->coul_tab1),
                glo_get_colB(edi->coul_tab1)
	);
      xi = CoulxCalcXImage (dataR, dataG, dataB, edi->cxdif, edi->cydif);
        
      XPutImage (dpy, xwin, edi->gc, xi, 0, 0, 0, 0, edi->cxdif, edi->cydif);
      XDestroyImage (xi); 
    }
    free (dataR); free (dataG); free (dataB);
  }

  /* Appel de client_repaint_proc */
  if (edi->client_repaint_proc != NULL)
    (*edi->client_repaint_proc)(edi);
}


/****************************************************************************************
 * appel direct de edi_repaint
 *
 ***************************************************************************************/

void edi_repaint_direct(edi)
Edi *edi;
{
  edi_repaint ( edi->canvas, edi->p_win, edi->dpy, edi->xwin, (Xv_xrectlist*) NULL);
}


/****************************************************************************************
 * changer la taille d'une fenetre editeur
 *
 ***************************************************************************************/

void edi_resize (canvas, width, height)
Canvas canvas;
int    width, height;
{
  Edi   *edi = (Edi *) xv_get (canvas, WIN_CLIENT_DATA);
  char   test;

#ifdef DEBUG
  printf ("edi_resize %4d %4d (cle = %d)\n", width, height, edi->cle_utilisation);
#endif

  /* Protection */
  if (edi->cle_utilisation != EDI_CLE_UTILISATION) return;

  /* taille du canvas */
  test = (width > edi->exdif || height > edi->eydif);
  edi->exdif = width;
  edi->eydif = height;
 
  edi_calc_edi (edi, FAUX);
  if (edi->loupe != 0 && edi->zoom > 20) edi->loupe = 0;
  if (edi->loupe != 0 && test) edi_loupe_quadri (edi);

  rep_repaint_direct (edi);

  /* Appel de client_resize_proc */
  if (edi->client_resize_proc != NULL)
    (*edi->client_resize_proc)(edi, width, height);
}


/****************************************************************************************
 * recalcul de Edi *edi
 *
 ***************************************************************************************/

void edi_calc_edi (edi, centrer)
Edi *edi;
int centrer;        
{
  int k1, k2, k;

  /* taille canvas de depart */
  edi->cxdif = edi->exdif;
  edi->cydif = edi->eydif;

  /* mise a jour du zoom */
  k1 = (edi->cxdif - 1)/edi->xsiz1 +1;
  k2 = (edi->cydif - 1)/edi->ysiz1 +1;
  k = (k1 > k2) ? k1 : k2;
  if (edi->zoom < k) edi->zoom = k;
  if (edi->panel_slider_zoom != (Panel_item) NULL)
  xv_set (edi->panel_slider_zoom,
	PANEL_MIN_VALUE,	k,
	PANEL_MAX_VALUE,	k+19,
	PANEL_VALUE,		edi->zoom,
	NULL);

  /* mise a jour de la taille du canvas */
  k = edi->cxdif % edi->zoom; if (k > 0) edi->cxdif += edi->zoom - k; 
  k = edi->cydif % edi->zoom; if (k > 0) edi->cydif += edi->zoom - k; 

  /* taille de la fenetre sur pic */
  edi->bxdif = edi->cxdif / edi->zoom;
  edi->bydif = edi->cydif / edi->zoom;

  /* centrage eventuel */
  if (centrer) {
      edi->bxmin = (edi->bxmin + edi->bxmax - edi->bxdif) / 2;
      edi->bymin = (edi->bymin + edi->bymax - edi->bydif) / 2;
  }

  /* bornes de la nouvelle fenetre */
  edi->bxmax = edi->bxmin + edi->bxdif;
  edi->bymax = edi->bymin + edi->bydif;

  /* ajustement des bornes */
  edi_reborne(edi);
}


/****************************************************************************************
 * reborne bxmin, bxmax, bymin, bymax
 *
 ***************************************************************************************/

void  edi_reborne(edi)
Edi *edi;
{
  if (edi->bxmin < 0) { edi->bxmin = 0; edi->bxmax = edi->bxdif; }
  if (edi->bymin < 0) { edi->bymin = 0; edi->bymax = edi->bydif; }
  if (edi->bxmax > edi->xsiz1) { edi->bxmax = edi->xsiz1; edi->bxmin = edi->xsiz1 - edi->bxdif; }
  if (edi->bymax > edi->ysiz1) { edi->bymax = edi->ysiz1; edi->bymin = edi->ysiz1 - edi->bydif; }
}       


/****************************************************************************************
 *  Choix de la taille de la fenetre
 *
 ***************************************************************************************/

void edi_choix_taille (menu, menu_item)
Menu      menu;
Menu_item menu_item;
{ 
  Edi      *edi    = (Edi *)     xv_get (menu, MENU_CLIENT_DATA);
  char     *choice = (char*)     xv_get (menu_item, MENU_STRING);
  int       value, x, y;

  if      (!strcmp(choice, "whole"      )) value = 1; 
  else if (!strcmp(choice, "2 times"    )) value = 2;
  else if (!strcmp(choice, "3 times"    )) value = 3;
  else if (!strcmp(choice, "zoom" )) value = 5;
  else if (!strcmp(choice, "win 512"    )) value = 11; 
  else if (!strcmp(choice, "win 768"    )) value = 12; 
  else value = 1; 

  switch (value)
  {
    case  1 :
    case  2 :
    case  3 : x = value*edi->xsiz1;
              y = value*edi->ysiz1;
              break;
    case  5 : x = edi->zoom*edi->xsiz1; if (x > glo.scr_xm-20) x = glo.scr_xm-20;
              y = edi->zoom*edi->ysiz1; if (y > glo.scr_ym-40) y = glo.scr_ym-40;
              break;
    case 11 : x = y = 512;
              break;
    case 12 : x = y = 768;
              break;
  }

  if (!edi->loupe)
    if (x != edi->exdif || y != edi->eydif)
      edi->zoom = 1; /* alors on aura ensuite un resize */
  xv_set (edi->frame, XV_WIDTH, x+2, XV_HEIGHT, y+2, NULL);
}


/****************************************************************************************
 * Choix du menu vision
 *
 ***************************************************************************************/

void edi_choix_vision (menu, menu_item)
Menu      menu;
Menu_item menu_item;
{ 
  Edi      *edi    = (Edi *)     xv_get (menu, MENU_CLIENT_DATA);
  char     *choice = (char*)     xv_get (menu_item, MENU_STRING);
  Rect     *rect   = (Rect *) xv_get (xv_get(edi->frame,XV_ROOT), WIN_MOUSE_XY);  /* vol.7 p.286 */
  int       value, nat;

  if      (!strcmp(choice, "magnify V1 C2"	)) { nat = 3; value = 1; }
  else if (!strcmp(choice, "magnify V2 C1"	)) { nat = 3; value = 2; }
  else if (!strcmp(choice, "16 colors"		)) { nat = 4; value = IPS_COUL_16C; }
  else if (!strcmp(choice, "256 grey levels"	)) { nat = 4; value = IPS_COUL_64G; }
  else if (!strcmp(choice, "16 colors + grey"	)) { nat = 4; value = IPS_COUL_BWC; }
  else if (!strcmp(choice, "change selection"	)) { nat = 5; value = 1; }
  else if (!strcmp(choice, "Change"		)) { nat = 5; value = 1; }
  else { nat = 1; value = 1; }

  switch (nat)
  {
    case 3 :  /* mode loupe */
	edi->zoom  = 20;
	edi->loupe = value;
	edi_calc_edi (edi, VRAI);
	if (edi->zoom > 20) edi->loupe = 0;
	if (edi->loupe != 0) edi_loupe_quadri (edi);
	edi_repaint_direct (edi);
	rep_repaint_direct (edi);
	break;

    case 4 :  /* table de val_curs */
	((Image *)edi->ico1->obj)->coul_tab = glo_get_ctab_lut (value);
	messa_Send (MESSA_TO_ICO, edi->ico1, MESSA_LUT, VRAI, NULL);
	break;

    case 1 :  /* refresh */
	messa_Send (MESSA_TO_ICO, edi->ico1, MESSA_REFRESH, VRAI, NULL);
	break;

    case 5 : { /* change selec */

	/* Teste si selection ok */
	Ico *v_ico[5];
	int nombre;
	Image *im;

	if ( !ico_sel_scan1 (v_ico, 2, IPS_IMAGE, "images", &nombre)) return;

	if ( nombre == 0 ) {
	    pcp_avertissement ("WARNING :","You should select","one or two images");
	    return;
	}

	/* MAJ de tout le monde sauf cette fenetre d'edition */
	messa_Send (
	    MESSA_FROM_WIN_ID, edi->messa_index, 
	    MESSA_TO_ICO, edi->ico1, 
	    MESSA_REFRESH, VRAI,
	    0);

	/* Change les icones du client 
	 * 
	 * BUG 7/5/96 : les cas de figures etaient mal geres ;
	 * Solution : il faut d'abord retirer ico1 et ico2, puis
	 * ajouter v_ico[0], et eventuellement v_ico[1].
	 * 
	*/
	messa_ChangeIcoClient (edi->messa_index, edi->ico1->index_creat, 0);
	if (edi->ico1 != edi->ico2)
	messa_ChangeIcoClient (edi->messa_index, edi->ico2->index_creat, 0);
	messa_ChangeIcoClient (edi->messa_index, 0, v_ico[0]->index_creat);
	if (nombre == 2) 
	messa_ChangeIcoClient (edi->messa_index, 0, v_ico[1]->index_creat);

	edi->ico1 = v_ico[0];
	edi->ico2 = v_ico[nombre-1];

	/* MAJ de cette fenetre d'edition.
	 * Attention, si ico2 == ico1 on appelle quand meme edi_maj_par2() 
	*/
	im = (Image *) edi->ico1->obj;
	edi_maj_par1 (edi, im->tab, im->b.cmin, im->b.xsiz, im->b.ysiz, im->coul_tab);
	edi_maj_nom (edi, im->ch1, edi->ico1->index_creat, edi->ico2->index_creat);
	im = (Image *) edi->ico2->obj;
	edi_maj_par2 (edi, im->tab, im->b.cmin, im->b.xsiz, im->b.ysiz, im->coul_tab);
	edi_repaint_direct (edi);
	rep_repaint_direct (edi);

    }	break;

  }
}


/****************************************************************************************
 * Choix du zoom
 *
 ***************************************************************************************/

void edi_slider_zoom_proc (item, value, event)
Panel_item item;
int value;
Event *event;
{
  Edi  *edi = (Edi *) xv_get (item, PANEL_CLIENT_DATA);

  edi->zoom  = value;
  if (edi->zoom < 1) edi->zoom = 1;
  edi->loupe = 0;

  edi_calc_edi (edi, VRAI);
  edi_repaint_direct (edi);
  rep_repaint_direct (edi);
}


/****************************************************************************************
 * Appel de client_tools_proc
 *
 ***************************************************************************************/

void edi_choix_tools (menu, menu_item)
Menu      menu;
Menu_item menu_item;
{ 
    Edi      *edi     = (Edi *) xv_get (menu, MENU_CLIENT_DATA);
    char     *choice  = (char*) xv_get (menu_item, MENU_STRING);
    int       test    = FAUX;

    /* Appel de client_tools_proc */
    if (edi->client_tools_proc != NULL)
	test = (*edi->client_tools_proc)(edi, choice);

    if (test)
	messa_Send (MESSA_TO_ICO, edi->ico1, MESSA_REFRESH, VRAI, NULL);
}


/****************************************************************************************
 * Mise a jour de act_a et act_b pour EDI_VAL_A et EDI_VAL_B
 *
 ***************************************************************************************/

int  edi_choix_act (item,value,event)
Panel_item item;
int        value;
Event     *event;
{ 
  Edi *edi = (Edi *) xv_get (item, PANEL_CLIENT_DATA);

#ifdef DEBUG
  printf("edi_choix_act : %s\n", xv_get(item, PANEL_CHOICE_STRING, value));
#endif

  if (item == edi->panel_act_a)
      edi->act_a = value;
  else if (item == edi->panel_act_b)
      edi->act_b = value;
  else pcp_error ("edi_choix_act #01", "Unknown Panel_item", NULL);

  return XV_OK;
}


/****************************************************************************************
 * traitement d'un evenement souris
 *
 ***************************************************************************************/

void edi_event_proc (p_win,event)
Xv_Window p_win;
Event     *event;
{
  Edi     *edi       = (Edi *) xv_get (p_win, WIN_CLIENT_DATA);
  int      acte      = EDI_ACT_NULL;
  int      x, y;
  int      redess_tous = FAUX;
  int      redess_moi = FAUX;
  char     bla[256];

#ifdef DEBUG
  printf ("edi_event_proc action = %d  cle = %d\n", 
	event_action(event), edi->cle_utilisation);
#endif

  /* Protection */
  if (edi->cle_utilisation != EDI_CLE_UTILISATION) return;

  edi->sx = event_x(event);
  edi->sy = event_y(event);

  /*** Analyse de l'evenement `event' et attribution de `acte' ***/
  switch(event_action(event))
  {
    case ACTION_SELECT :
    case ACTION_ADJUST :
        if (event_action(event) == ACTION_SELECT) {
            edi->val_cur = EDI_GET_VAL_A(edi);
            edi->act_cur = edi->act_a;
	    edi->sb = EDI_MOUSE_A;
        }
        else {
            edi->val_cur = EDI_GET_VAL_B(edi);
            edi->act_cur = edi->act_b;
	    edi->sb = EDI_MOUSE_B;
        }
        if (event_is_down(event))
             if (edi->dedans == FAUX)
                  {
                    edi->dedans = VRAI;
                    acte        = EDI_ACT_ENFONCE;
                  }
             else {
                    edi->dedans = FAUX;
                    acte        = EDI_ACT_ANNULE;
                  }
        else if (edi->dedans == VRAI)
             {
               edi->dedans = FAUX;
               acte        = EDI_ACT_RELACHE;
             }
        break;
    case LOC_DRAG :
        if (edi->dedans == VRAI)
        if (0 <= edi->sx && edi->sx < edi->cxdif &&
            0 <= edi->sy && edi->sy < edi->cydif)
             {
               acte  = EDI_ACT_TIRE;
             }
        else { 
               edi->dedans = FAUX;
               acte        = EDI_ACT_ANNULE;
             }
        break;
    case ACTION_MENU :
        if (event_is_down(event))
	    edi_menu_contextuel (edi, event);
        break;
    case LOC_MOVE :
        acte = EDI_ACT_DEPLA;
        break;
    case LOC_WINEXIT :
        acte = EDI_ACT_SORTIE;
        break;
    default : return ; /* car xview peut envoyer d'autres events .. */
  }

    /* Execution de l'acte */
    if ( (edi->sb == EDI_MOUSE_A && edi->act_cur == edi->act_a_move) ||
         (edi->sb == EDI_MOUSE_B && edi->act_cur == edi->act_b_move) ) {

	switch(acte) { /* Move */
	    case EDI_ACT_ENFONCE :
	        x = (edi->sx - edi->cxdif/2) / edi->zoom;
	        y = (edi->sy - edi->cydif/2) / edi->zoom;
	        /* ajustement des bornes */
	        edi->bxmin += x; edi->bxmax += x;
	        edi->bymin += y; edi->bymax += y;
	        edi_reborne(edi);
	        redess_moi = VRAI; acte = EDI_ACT_ANNULE;
	        break;
	    case EDI_ACT_RELACHE :
	        acte = EDI_ACT_DEPLA;
	        break;
	    case EDI_ACT_TIRE : 
	    case EDI_ACT_ANNULE :
	        acte = EDI_ACT_ANNULE;
	        break;
	}
    }
    /* appel de client_event_proc */
    else if (edi->client_event_proc != NULL)
	redess_tous = (*edi->client_event_proc)(edi, acte);

  /* action dans la fenetre repere */
  switch(acte)
  {
    case EDI_ACT_ENFONCE :
    case EDI_ACT_TIRE :
        x = edi->sx / edi->zoom + edi->bxmin - edi->rep.bx;
        y = edi->sy / edi->zoom + edi->bymin - edi->rep.by;
        sprintf(bla, "dx = %d  dy = %d", x, y);
	edi_footer (edi, bla);
        break;
    case EDI_ACT_DEPLA :
        edi->rep.bx = edi->sx / edi->zoom + edi->bxmin;
        edi->rep.by = edi->sy / edi->zoom + edi->bymin;
        sprintf(bla, "x = %d  y = %d  v = %d", edi->rep.bx, edi->rep.by, 
	    edi->tab1[(edi->rep.by+edi->cmin1)*edi->xtot1 + edi->rep.bx+edi->cmin1]);
	edi_footer (edi, bla);
        break;
    case EDI_ACT_RELACHE :
    case EDI_ACT_ANNULE :
    case EDI_ACT_SORTIE :
	edi_footer (edi, "");
       break;
  }

    if (redess_tous)
	messa_Send (MESSA_TO_ICO, edi->ico1, MESSA_REFRESH, VRAI, NULL);
    if (redess_moi) {
	edi_repaint_direct (edi);
	rep_repaint_direct (edi);
    }
}


/****************************************************************************************
 * Initialisation du menu contextuel
 *
 ***************************************************************************************/
void edi_menu_pane_init ()
{
    edi_menu_pane = (Menu) xv_create (0, MENU,
	MENU_TITLE_ITEM, "Edit",
	MENU_STRINGS, "Marker", 0,

	MENU_ITEM, MENU_STRING, "Size", MENU_PULLRIGHT, xv_create (0, MENU,
	    MENU_STRINGS, "whole", "2 times","3 times","zoom", "win 512","win 768", 0,
	    MENU_NOTIFY_PROC, edi_menu_pane_proc, 0), 0,

	MENU_ITEM, MENU_STRING, "Zoom", MENU_PULLRIGHT, xv_create (0, MENU,
	    MENU_STRINGS, "+", "-", "*2", "/2", 0,
	    MENU_NOTIFY_PROC, edi_menu_pane_proc, 0), 0,

	MENU_ITEM, MENU_STRING, "Color", MENU_PULLRIGHT, xv_create (0, MENU,
	    MENU_STRINGS, "16 colors","256 grey levels", "16 colors + grey", 0,
	    MENU_NOTIFY_PROC, edi_menu_pane_proc, 0), 0,

	MENU_STRINGS, "Refresh", "Change", 0,
	MENU_NOTIFY_PROC, edi_menu_pane_proc, 
    0); 
}


/****************************************************************************************
 * Appel du menu contextuel
 *
 ***************************************************************************************/
void edi_menu_contextuel (edi, event)
Edi *edi;
Event *event;
{
    xv_set (edi_menu_pane, MENU_CLIENT_DATA, edi, NULL);
    event->ie_locx += (int) xv_get (edi->canvas, XV_X);
    event->ie_locy += (int) xv_get (edi->canvas, XV_Y);
    menu_show (edi_menu_pane, event->ie_win, event, NULL);
}


/****************************************************************************************
 * Callback du menu contextuel
 *
 ***************************************************************************************/
void edi_menu_pane_proc (menu, menu_item)
Menu menu;
Menu_item menu_item;
{ 
    char *choix = (char *) xv_get (menu_item, MENU_STRING);
    Edi  *edi;

    /* Attention, 'menu' peut etre un sous-menu, 
     * alors que le client-data est attache' a edi_menu_pane (le pere).
    */
    menu = edi_menu_pane;
    edi = (Edi *) xv_get (menu, MENU_CLIENT_DATA);

    if (strcmp (choix, "Marker") == 0) {

	edi->rep.show = TRUE;
	xv_set ( edi->rep.frame,
	    FRAME_CMD_PUSHPIN_IN, edi->rep.show,
	    XV_SHOW, edi->rep.show, 
	    NULL);
	rep_repaint_direct (edi);

    } else if (	strcmp (choix, "whole"   ) == 0 ||
		strcmp (choix, "2 times" ) == 0 ||
		strcmp (choix, "3 times" ) == 0 ||
		strcmp (choix, "zoom"    ) == 0 ||
		strcmp (choix, "win 512" ) == 0 ||
		strcmp (choix, "win 768" ) == 0 ) {

	edi_choix_taille (menu, menu_item);

    } else if (	strcmp (choix, "Refresh"          ) == 0 ||
		strcmp (choix, "Change"           ) == 0 ||
		strcmp (choix, "16 colors"        ) == 0 ||
		strcmp (choix, "256 grey levels"  ) == 0 ||
		strcmp (choix, "16 colors + grey" ) == 0 ) {

	edi_choix_vision (menu, menu_item);

    } else {

	int k;

	if      (strcmp (choix, "+" ) == 0) edi->zoom ++ ;
	else if (strcmp (choix, "-" ) == 0) edi->zoom -- ;
	else if (strcmp (choix, "*2") == 0) edi->zoom *= 2;
	else if (strcmp (choix, "/2") == 0) edi->zoom /= 2;
	else return;

	if (edi->zoom < 1) edi->zoom = 1;
	k = (int) xv_get (edi->panel_slider_zoom, PANEL_MAX_VALUE);
	if (edi->zoom > k) edi->zoom = k;
	edi->loupe = 0;

	edi_calc_edi (edi, VRAI);
	edi_repaint_direct (edi);
	rep_repaint_direct (edi);
    }
}


/****************************************************************************************
 * Initialisation de rep
 *
 ***************************************************************************************/

void rep_init (edi)
Edi *edi;
{
    int b1 = 128, b2 = 192, g = max (edi->xsiz1, edi->ysiz1);

    /* calcul du zoom et du step avec taille desiree b1 et taille max b2 */
    edi->rep.zoom = 1;
    edi->rep.step = 1;
    if (g < b1) {
	edi->rep.zoom = (b1 - 1)/g +1;
	if (g * edi->rep.zoom > b2) edi->rep.zoom = b2 / g;
    }
    else if (g > b1) {
	edi->rep.step = g / b1;
	if (g / edi->rep.step > b2) edi->rep.step = (g - 1)/b2 + 1;
    }

    /* mise a jour de la taille du repere */
    edi->rep.xm = edi->xsiz1 * edi->rep.zoom / edi->rep.step;
    edi->rep.ym = edi->ysiz1 * edi->rep.zoom / edi->rep.step;
}


/****************************************************************************************
 * cacher une fenetre repere
 *
 ***************************************************************************************/

void rep_cacher_frame (frame)
Frame frame;
{
  Edi *edi = (Edi *) xv_get (frame, WIN_CLIENT_DATA);

  xv_set (frame, XV_SHOW, FALSE, NULL);
 
  edi->rep.show = FAUX;
}


/****************************************************************************************
 * affichage dans le canvas repere 
 *
 ***************************************************************************************/

void rep_repaint (canvas, p_win, dpy, xwin, area)
Canvas       canvas;
Xv_Window    p_win;
Display      *dpy;
Window       xwin;
Xv_xrectlist *area;
{
  Edi     *edi    = (Edi *) xv_get (canvas, WIN_CLIENT_DATA);
  int      nb_x   = (edi->rep.xm-1) / edi->rep.zoom +1;
  int      nb_y   = (edi->rep.ym-1) / edi->rep.zoom +1;
  int      taille = nb_x * nb_y * edi->rep.zoom * edi->rep.zoom;
  XImage  *xi;
  int      x, y;

  if (glo.depth <= 8) {
      char    *data;
      if ((data = (char*) calloc (taille, sizeof(char))) != NULL)
      {
        if (edi->tab1 != NULL)
        edi_vecteur_ecran ( data, edi->rep.zoom, edi->rep.step, edi->cmin1, edi->cmin1,
                             nb_x, nb_y, edi->xtot1, edi->tab1, edi->coul_tab1);
        xi = XCreateImage (edi->rep.dpy, edi->rep.visual, edi->rep.depth, ZPixmap, 0, data,
                             nb_x * edi->rep.zoom, nb_y * edi->rep.zoom, 8, 0);
        XPutImage (edi->rep.dpy, edi->rep.xwin, edi->rep.gc, xi, 0, 0, 0, 0, edi->rep.xm, edi->rep.ym);
        XDestroyImage (xi);  /* libere aussi data */
      }
      else pcp_error ("rep_repaint #1", "malloc error", NULL);
      
  } else { /* mode RGB */
  
    char *dataR = NULL, *dataG = NULL, *dataB = NULL;
    if ( (dataR = (char*) calloc (taille, sizeof(char))) == NULL ||
         (dataG = (char*) calloc (taille, sizeof(char))) == NULL ||
         (dataB = (char*) calloc (taille, sizeof(char))) == NULL )
    pcp_error ("rep_repaint #2", "malloc error", NULL);
    else {
      if (edi->tab1 != NULL)
        edi_vecteur_ecran_RGB ( dataR, dataG, dataB,
        	edi->rep.zoom, edi->rep.step, edi->cmin1, edi->cmin1,
                nb_x, nb_y, edi->xtot1, edi->tab1, 
                glo_get_colR(edi->coul_tab1),
                glo_get_colG(edi->coul_tab1),
                glo_get_colB(edi->coul_tab1)
	);
      xi = CoulxCalcXImage (dataR, dataG, dataB, 
      	  nb_x * edi->rep.zoom, nb_y * edi->rep.zoom);
        
      XPutImage (edi->rep.dpy, edi->rep.xwin, edi->rep.gc, xi, 
      	0, 0, 0, 0, edi->rep.xm, edi->rep.ym);
      XDestroyImage (xi); 
    }
    free (dataR); free (dataG); free (dataB);
  }
  rep_calc_cadre (edi);
  rep_affi_cadre(edi->rep);
}


/****************************************************************************************
 * appel direct de rep_repaint 
 *
 ***************************************************************************************/

void rep_repaint_direct(edi)
Edi *edi;
{
  if (edi->rep.show)
      rep_repaint ( edi->rep.canvas, edi->rep.p_win, edi->rep.dpy,
          edi->rep.xwin, (Xv_xrectlist*) NULL);
}


/****************************************************************************************
 * recalcul des coord du cadre dans rep 
 *
 ***************************************************************************************/

void rep_calc_cadre(edi)
Edi *edi;
{
  edi->rep.xmin = edi->bxmin * edi->rep.xm / edi->xsiz1;
  edi->rep.xmax = edi->bxmax * edi->rep.xm / edi->xsiz1;
  edi->rep.ymin = edi->bymin * edi->rep.ym / edi->ysiz1;
  edi->rep.ymax = edi->bymax * edi->rep.ym / edi->ysiz1;
  if (edi->rep.xmax >= edi->rep.xm) edi->rep.xmax = edi->rep.xm - 1;
  if (edi->rep.ymax >= edi->rep.ym) edi->rep.ymax = edi->rep.ym - 1;
  if (edi->rep.xmax - edi->rep.xmin < 4) edi->rep.xmax = edi->rep.xmin + 4;
  if (edi->rep.ymax - edi->rep.ymin < 4) edi->rep.ymax = edi->rep.ymin + 4;
}


/****************************************************************************************
 * affiche un rectangle en relief 
 *
 ***************************************************************************************/

void rep_rect_relief(rep, a, c)
Rep      rep;
int a, c;
{
  XSetForeground (rep.dpy, rep.gc, coul_16c[c]);
  XDrawLine (rep.dpy, rep.xwin, rep.gc, rep.xmin-a, rep.ymin-a, rep.xmax+a, rep.ymin-a);
  XDrawLine (rep.dpy, rep.xwin, rep.gc, rep.xmin-a, rep.ymin-a, rep.xmin-a, rep.ymax+a);
  XDrawLine (rep.dpy, rep.xwin, rep.gc, rep.xmax-a, rep.ymax-a, rep.xmax-a, rep.ymin+a);
  XDrawLine (rep.dpy, rep.xwin, rep.gc, rep.xmax-a, rep.ymax-a, rep.xmin+a, rep.ymax-a);
}


/****************************************************************************************
 * affiche le cadre 
 *
 ***************************************************************************************/

void  rep_affi_cadre(rep)
Rep      rep;
{
  rep_rect_relief(rep, 0, 7);
  rep_rect_relief(rep,-1, 8);
  rep_rect_relief(rep, 1, 15);
}


/****************************************************************************************
 * traitement d'un evenement souris 
 *
 ***************************************************************************************/

void rep_event_proc (p_win,event)
Xv_Window p_win;
Event     *event;
{
  Edi     *edi       = (Edi *)    xv_get (p_win, WIN_CLIENT_DATA);
  int      acte      = EDI_ACT_NULL;
  char     bla[256];
  int sx, sy;

  sx = event_x(event) * edi->xsiz1 / edi->rep.xm;
  sy = event_y(event) * edi->ysiz1 / edi->rep.ym;

  /*** Analyse de l'evenement `event' et attribution de `acte' ***/
  switch(event_action(event))
  {
    case ACTION_SELECT :
    case ACTION_ADJUST :
        if (event_is_down(event) && edi->dedans == FAUX)
          {
            /* deplacement bornes */
            edi->bxmin = sx - edi->bxdif / 2;
            edi->bymin = sy - edi->bydif / 2;
            edi->bxmax = sx + edi->bxdif / 2 +  edi->bxdif % 2;
            edi->bymax = sy + edi->bydif / 2 +  edi->bydif % 2;
            edi_reborne (edi);
            acte = EDI_ACT_DEPLA;
            edi_repaint_direct (edi);
            rep_repaint_direct (edi);
          }
        break;
    case LOC_MOVE :
        acte = EDI_ACT_DEPLA;
        break;
    case LOC_WINEXIT :
        acte = EDI_ACT_SORTIE; 
        break;
    default : return ; /* car xview peut envoyer d'autres events .. */
  }

  switch(acte)
  {
    case EDI_ACT_DEPLA :
	if (edi->tab1 != NULL)
             sprintf(bla, "x = %d  y = %d,  v = %d", sx, sy,
		edi->tab1[(sy+edi->cmin1)*edi->xtot1 + sx+edi->cmin1]);
        else sprintf(bla, "x = %d  y = %d", sx, sy);
	edi_footer (edi, bla);
        break;
    case EDI_ACT_SORTIE :
	edi_footer (edi, "");
        break;
  }
}


/****************************************************************************************
 * Mise a jour des parametres de l'image 1 (sauf le nom et le numero)
 *
 ***************************************************************************************/

void	edi_maj_par1 (edi, tab1, cmin1, xsiz1, ysiz1, coul_tab1)
Edi 	*edi;
Unt16 	*tab1;
int 	cmin1, xsiz1, ysiz1;
Unt32 	*coul_tab1;
{
    int  resize = (edi->xsiz1 != xsiz1 || edi->ysiz1 != ysiz1);
 
    /* MAJ Params */
    edi->tab1	= tab1;
    edi->cmin1	= cmin1;
    edi->xsiz1	= xsiz1;
    edi->ysiz1	= ysiz1;
    edi->xtot1  = edi->xsiz1 + 2*edi->cmin1;

    /* MAJ coul_tab ; reafi en dehors de edi_maj_par1 */ 
    edi->coul_tab1 = coul_tab1;

    /* si resize, recalcul bornes, zoom, loupe ;
     * reafi en dehors de edi_maj_part1
     * Attention : resizer le canvas repere
    */
    if (resize) {
	Panel panel = (Panel) xv_get (edi->rep.frame, FRAME_CMD_PANEL);

        edi_calc_edi (edi, FAUX);
        if (edi->loupe != 0 && edi->zoom > 20) edi->loupe = 0;
        rep_init (edi);

        xv_set (edi->rep.canvas,
	    XV_X,	((int) xv_get (panel, XV_WIDTH) - edi->rep.xm+2) /2,
	    XV_WIDTH,	edi->rep.xm+2,
	    XV_HEIGHT,	edi->rep.ym+2,
	    0);

	xv_set (panel, 
	    XV_HEIGHT, (int) xv_get (edi->rep.canvas, XV_Y) + edi->rep.ym+2, 
	    0);
	window_fit (edi->rep.frame);
    }
}


/****************************************************************************************
 * Mise a jour des parametres de l'image 2 
 *
 ***************************************************************************************/

void	edi_maj_par2 (edi, tab2, cmin2, xsiz2, ysiz2, coul_tab2)
Edi 	*edi;
Unt16 	*tab2;
int 	cmin2, xsiz2, ysiz2;
Unt32 	*coul_tab2;
{
    edi->tab2	= tab2;
    edi->cmin2	= cmin2;
    edi->xsiz2	= xsiz2;
    edi->ysiz2	= ysiz2;
    edi->xtot2  = edi->xsiz2 + 2*edi->cmin2;
    edi->coul_tab2 = coul_tab2;
}


/****************************************************************************************
 * Mise a jour du nom de la fenetre : 
 *    "n. 1 - titre"
 *    "n. 1 + 2 - titre"  si num1 != num2
 *
 ***************************************************************************************/

void	edi_maj_nom (edi, name, num1, num2)
Edi 	*edi;
char 	*name;
int	num1, num2;
{
    char s_name[256];
 
    /* MAJ noms */
    if (num1 == num2)
	 sprintf (s_name, "n. %d", num1);
    else sprintf (s_name, "n. %d + %d", num1, num2);
    xv_set (edi->rep.frame, FRAME_LABEL, s_name, NULL);
    sprintf (s_name, "%s - %s", s_name, name);
    xv_set (edi->frame, FRAME_LABEL, s_name, NULL);
}


/****************************************************************************************
 * _messaProc de la fenetre d'edition 
 *
 ***************************************************************************************/

void edi_messaProc (client_data, message)
void     *client_data;
Messa_ev *message;
{
    Edi *edi      = (Edi *) client_data;
    int  repaint  = FAUX,
         for_ico1 = messa_ForIco (edi->ico1, message),
         for_ico2 = messa_ForIco (edi->ico2, message);

#   ifdef DEBUG
    printf ("edi_messaProc %d\n", edi->messa_index);
#   endif

    /*
     * ATTENTION loupe, distinguer refresh edi_ et rep_  et mag1, mag2 !!
    */
    if (messa_lut (message)) {
	if (for_ico1) {
	    edi->coul_tab1 = ((Image *)edi->ico1->obj)->coul_tab;
	    repaint = VRAI;
	}
	if (for_ico2) {
	    edi->coul_tab2 = ((Image *)edi->ico2->obj)->coul_tab;
	    repaint = VRAI;
	}
    }

    if (messa_refresh (message)) {
	repaint = VRAI;
    }

    if (messa_done (message)) {
	repaint = VRAI;
    }

    if (messa_rescan (message)) {
	if (for_ico1) {
	    Image *im = (Image *) edi->ico1->obj;
	    edi_maj_par1 (edi, im->tab, im->b.cmin, im->b.xsiz, im->b.ysiz, 
		im->coul_tab);
	}
	if (for_ico2) {
	    Image *im = (Image *) edi->ico2->obj;
	    edi_maj_par2 (edi, im->tab, im->b.cmin, im->b.xsiz, im->b.ysiz, 
		im->coul_tab);
	}
	if (for_ico1 || for_ico2) {
	    Image *im = (Image *) edi->ico1->obj;
	    edi_maj_nom (edi, im->ch1, edi->ico1->index_creat, edi->ico2->index_creat);
	}
    }

    if (repaint) {
	if (!( for_ico2 && !for_ico1 && edi->loupe == 0 ))
	    edi_repaint_direct (edi);
	if (for_ico1)
	    rep_repaint_direct (edi);
    }

    if (messa_kill (message)) {
	edi_tuer_edi (edi, EDI_DONE_BY_MESSA);
    }

}

/****************************************************************************************
 * Sauver l'image pour le undo
 *
 * Renvoie -1 si impossible, 0 si succes
 ***************************************************************************************/
int edi_undo_save (edi)
Edi *edi;
{
    int x, y;

    if (edi_undo_pic != (Unt16 *) NULL) free (edi_undo_pic);
    edi_undo_pic = (Unt16 *) malloc (edi->xsiz1 * edi->ysiz1 * sizeof (Unt16));
    if (edi_undo_pic == (Unt16 *) NULL) {
	edi_footer (edi, "Mem error, aborted");
	return -1;
    }

    edi_footer (edi, "Saving for undo ...");

    edi_undo_xsiz = edi->xsiz1;
    edi_undo_ysiz = edi->ysiz1;

    for (y = 0; y < edi->ysiz1; y++)
    for (x = 0; x < edi->xsiz1; x++)
	edi_undo_pic[y*edi_undo_xsiz + x] =
            edi->tab1[(y+edi->cmin1)*edi->xtot1 + x+edi->cmin1]; 

    edi_footer (edi, "Undo is available");
    return 0;
}

/****************************************************************************************
 * Effectue le undo si c'est possible
 *
 ****************************************************************************************/
void edi_undo_now (edi)
Edi *edi;
{
    int x, y, t1, t2;
    Unt16 c;

    if (edi_undo_pic == (Unt16 *) NULL || 
	edi_undo_xsiz != edi->xsiz1 ||
	edi_undo_ysiz != edi->ysiz1 ) {
	edi_footer (edi, "Nothing to undo");
	return;
    }

    for (y = 0; y < edi->ysiz1; y++)
    for (x = 0; x < edi->xsiz1; x++) {

	t1 = (y+edi->cmin1)*edi->xtot1 + x+edi->cmin1;
	t2 = y*edi_undo_xsiz + x;
	c = edi->tab1[t1]; edi->tab1[t1] = edi_undo_pic[t2]; edi_undo_pic[t2] = c;
    }
        
}


/****************************************************************************************
 * Affiche message dans le footer
 *
 ****************************************************************************************/
edi_footer (edi, bla)
Edi *edi;
char *bla;
{
    xv_set (edi->rep.frame, FRAME_LEFT_FOOTER, bla, NULL);
}


