/***************************************************************************************/
/* globa.h                                                    I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* declaration des variables globales en extern          Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


/* Type global fourre-tout */

typedef struct st_glo { 
	Frame		frame_principal;	/* frame principal			*/
	Panel		panel1;			/* panel horizontal : barre des menus	*/
	Canvas		canvas;			/* canvas principal			*/

        Selection_requestor sel_req;            /* Pour le drag-and-drop                */
        Xv_drop_site	drop_site;
	Dnd		dnd;
	Xv_server	server;

	Ico		*l_ico_z,		/* liste des icones dans l'ordre z	*/
			*l_ico_a,		/* liste des icones dans l'ordre affi	*/
			*clic;			/* icone courant			*/

	double		clic_time,		/* date du clic				*/
			clic_time_prev,		/* date du clic precedent		*/
			clic_timeout;		/* Interv tps max pr double clic souris	*/

	Unt32		c[7];			/* couleurs des icones (cf globa.c)	*/

	Display		*dpy;			/* Parametres pour l'affichage en X11	*/
	Visual		*visual;		/* dans le Canvas principal		*/
	Xv_Window	p_win;
	Window		xwin;
	int		screen,
			depth,
			bitmap_pad,		/* 8, 16 ou 32 selon depth		*/
			scr_xm, scr_ym;		/* Dimensions de l'ecran		*/
	GC		gc;
        Xv_Font		petite_fonte;		/* petite fonte pour les Ico		*/

	int		font_a, font_d, font_h,	/* hauteurs de la petite_fonte		*/
			font_l,			/* largeur d'1 espace			*/
			s_bouton,		/* bouton actif dans ico_event_proc	*/
			s_bouge,		/* param pour ico_event_proc		*/
			s_actb1, s_actb2,	/* actes lies aux boutons b1, b2	*/
			prev_action,		/* memo action prec dans ico_eventProc	*/
			sx, sy,			/* coordonnees de la souris		*/
			x1, y1, x2, y2,		/* coord pour les drag			*/
			canvas_xm, canvas_ym,	/* taille canvas principal		*/
			index_creat,		/* incremente a chaque ico_creat	*/
			index_selec,		/* incremente a chaque selection	*/
			nb_alloc;		/* nb actuel de pointeurs alloues	*/
	char		*chemin,		/* chemin lu dans argv[0]		*/
			*home_dir,		/* home directory			*/
			*host_name;		/* nom de la machine			*/
	} Glo;


/* Variables globales extern */

extern Glo	glo;
extern Cms	cms_palette;
extern Unt32	coul_16c[256], coul_64g[256], coul_bwc[256], *coul_pic;
extern Unt8     colR_16c[256], colG_16c[256], colB_16c[256], 
                colR_64g[256], colG_64g[256], colB_64g[256], 
                colR_bwc[256], colG_bwc[256], colB_bwc[256];

/* Fonction du module */
extern void  globa_init_CMS	();
extern void  globa_init_LUTS	();
extern int   glo_get_attr_lut	();
extern Unt32 *glo_get_ctab_lut	();
extern Unt8 *glo_get_colR ();
extern Unt8 *glo_get_colG ();
extern Unt8 *glo_get_colB ();
