/***************************************************************************************/
/* icobox.h                                                   I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* gestion des icones                                    Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


/* Type des icones */

typedef	struct st_ico { 
	int		xb, yb,			/* coordonnees de base			*/
			xm, ym,			/* taille --> [ xb , xb+xm-1]		*/
			raf,			/* booleen pour le rafraichissement	*/
			sel,			/* booleen pour la selection		*/
			lock;			/* indique si l'icone est bloque'	*/

	struct st_ico	*pz;			/* icone suivant dans l'ordre z		*/
	struct st_ico	*pa;			/* icone suivant dans l'ordre affich	*/

	int		nat_obj;		/* ICO_IMAGE, ICO_OUTIL, ICO_MACRO	*/
	void		*obj;			/* objet associe a Ico, suivant nat_obj	*/

	Menu		menu;			/* menu de l'icone			*/
	int		index_creat, 		/* index de creation; =0 si delete	*/
			index_selec;		/* index de selection, a trier		*/
        } Ico;


/* Protection des icones.
 *
 * Usage : lock = LOCK_CLEAR | LOCK_DUPLIC 
 *         if (lock & LOCK_CLEAR) ; if ((lock & LOCK_CLEAR) == 0)
*/
#define LOCK_NO		0x0000
#define LOCK_CLEAR	0x0001
#define LOCK_DUPLIC	0x0002
#define LOCK_RUN	0x0004
#define LOCK_MODIF	0x0008



extern void  ico_init			();
extern Ico  *ico_creat			();
extern void  ico_tete_pz		();
extern void  ico_tete_pa		();
extern void  ico_enlever_maillon	();
extern void  ico_free			();
extern Ico  *ico_duplic 		();
extern Ico  *ico_get_from_index_creat	();
extern Ico  *ico_find_clic		();
extern int   ico_inter			();
extern int   ico_inter_zone		();
extern void  ico_init_raf		();
extern void  ico_inter_raf		();
extern void  ico_inter_crible		();
extern int   ico_is_front		();
extern void  ico_posit_clic		();
extern void  ico_refresh_now		();
extern void  ico_depla_clic		();
extern void  ico_homot_clic		();
extern void  ico_display_inside		();
extern void  ico_douane			();
extern void  ico_index_selec		();
extern void  ico_tri_selec		();
extern void  ico_unsel_sel_one		();
extern void  ico_sel_ensemble		();
extern void  ico_sel_drag_xor		();
extern void  ico_sel_get_raf		();
extern int   ico_sel_get_nb		();
extern void  ico_depla_sel		();
extern void  ico_duplic_sel		();
extern void  ico_sel_display		();
extern void  ico_clear_sel		();
extern void  ico_affi_fond		();
extern void  ico_affi_rect_3d		();
extern void  ico_affi_rect_xor		();
extern void  ico_affi_rec2_xor		();
extern void  ico_affi_bord_xor		();
extern void  ico_bascule_xor		();
extern void  ico_affi_ico		();
extern void  ico_affi_raf		();
extern void  ico_repaint		();
extern void  ico_repaint_direct		();
extern void  ico_resize			();
extern int   ico_analyse_souris		();
extern void  ico_event_proc		();
extern void  ico_menu_affi		();
extern void  ico_menu_pane_proc		();
extern int   ico_sel_scan1		();
extern int   ico_sel_scan2		();
extern int   ico_sel_scan3		();


