/***************************************************************************************/
/* messa.h                                                    I.P.S  v 3.3   17/3/1994 */
/*                                                                                     */
/* gestion des messages                                  Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/

#define MESSA_FROM_ICO			21001
#define MESSA_FROM_ICO_ID		21002
#define MESSA_FROM_WIN_ID		21003
#define MESSA_TO_ICO			21004
#define MESSA_TO_ICO_ID			21005
#define MESSA_TO_ICO_ID_LIST		21006
#define MESSA_KILL			21007
#define MESSA_DONE			21008
#define MESSA_RESCAN			21009
#define MESSA_REFRESH			21010
#define MESSA_REDRAW_RECT		21011
#define MESSA_LUT			21012
#define MESSA_NAME			21013


#define MESSA_MAX_ICO_N			8

/*
 * Structure de memorisation d'un client pour qu'il recoive les messages
*/

typedef struct {
	void		(*messaProc)(),
			*client_data;
	int		index_creat,
			ico_ind_v[MESSA_MAX_ICO_N],	/* index icos concernes par 	*/
			ico_ind_n;			/*   ce client			*/
	} Messa_client;


/*
 * Structure d'un message envoye aux clients
*/

typedef struct {
	int		from_who,
			from_index,
			ico_ind_v[MESSA_MAX_ICO_N],
			ico_ind_n,
			b_refresh,
			b_kill,
			b_done,
			b_rescan,
			b_lut,
			b_name,
			b_redraw_rect,
			xb, yb, xm, ym;
	} Messa_ev;

/*
 * Macros
*/
#define messa_from_ico(m)		(m->from_who == MESSA_FROM_ICO)
#define messa_from_win(m)		(m->from_who == MESSA_FROM_WIN)
#define messa_kill(m)			(m->b_kill)
#define messa_done(m)			(m->b_done)
#define messa_rescan(m)			(m->b_rescan)
#define messa_refresh(m)		(m->b_refresh)
#define messa_lut(m)			(m->b_lut)
#define messa_name(m)			(m->b_name)
#define messa_redraw_rect(m)		(m->b_redraw_rect)

/*
 * Fonctions
*/

extern int  messa_NewClient	();
extern void messa_DeleteClient	();
extern void messa_Send		(int ordre, ...);
extern int  messa_ForIco	();
extern int  messa_ForIcoInd	();


