/***************************************************************************************/
/* obj_oper.h                                                 I.P.S  v 3.1  18/11/1993 */
/*                                                                                     */
/* gestion de l'objet oper (ico->nat_obj = ICO_OPER)     Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


/* Type Oper */

typedef struct {
	int		led_busy,		/* 0=sleep, 1=wait, 2=running		*/
			nb_image_in,		/* nb d'images en entree		*/
			nb_image_out,		/* nb d'images en sortie		*/
			same_size,		/* booleen: meme taille des images	*/
			val_cadre,		/* -1 : qcq!=0 ; x>=0 : cadre a x	*/
			mot_x,			/* largeur max des sous-titres		*/
			attach_n, *attach_v,	/* nb attach, vecteur des nums des icos	*/
                        param_nb,		/* nb de params				*/
                        *param_type;		/* vecteur des types des parametres	*/
	void            **param_adr;		/* vecteur des adresses des parametres	*/
	char		*titre,			/* titre de l'oper			*/
                        *idf,			/* identificateur lu dans ressource	*/
			**lgd_images;		/* Legendes pr les images en in,out	*/
	Frame		frame_parbox;		/* Frame de la boite de dialogue 	*/
	} Oper;


/* Types de parametres pour les opers */

typedef struct {
	char		*legende;		/* Legende du parametre			*/
	int		inf, sup,		/* Borne inf et sup du parametre	*/
			defaut, valeur;		/* Valeur par defaut et choisie		*/
	} Oper_par_int;

typedef struct {
	char		*legende;		/* Legende du parametre			*/
	double		inf, sup,		/* Borne inf et sup du parametre	*/
			defaut, valeur;		/* Valeur par defaut et choisie		*/
	} Oper_par_real;

typedef struct {
	char		*legende,		/* Legende du parametre			*/
			*defaut, *valeur;	/* Texte par defaut et choisi		*/
	int		taille_max;		/* Taille max du string valeur		*/
	} Oper_par_text;

typedef struct {
        char            *legende,               /* Legende du parametre			*/
			**choices;		/* Noms des choix uniques		*/
	int		nchoice,		/* Nombre de choix			*/
			defaut, valeur;		/* Bouton par defaut et choisi		*/
        } Oper_par_choice;


/* Type pour le client_data des parbox */

typedef struct {
	Ico		*ico;			/* Adresse de l'icone			*/
	Oper		*oper;			/* Adresse de l'oper			*/
	int		*adr;			/* Adresses des champs de saisie	*/
	} Oper_parbox;


extern void		 oper_init				();
extern void		 oper_free 				();
extern void		 oper_duplic				();
extern void		 oper_affi_ico				();
extern void		 oper_prepare_noms			();
extern void		 oper_def	(Oper *op, int mode,  ...);
extern void		 oper_set	(Oper *op, int ordre, ...);
extern void		*oper_get	(Oper *op, int ordre, ...); 
extern void		 oper_check_run				();
extern int		 oper_exec				();
extern void		 oper_parbox_creat			();
extern int		 oper_parbox_butt_panel_proc		();
extern void		 oper_parbox_butt_menu_proc		();
extern void		 oper_parbox_butt_direct		();
extern void		 oper_parbox_par_choice_proc		();
extern void		 oper_parbox_kill			();
extern int		 oper_attach				();
extern void		 oper_detach				();
extern Panel_item	 oper_FramePcpButtCreat			();
extern void		 oper_FramePcpMenuProc			();
extern void		 oper_CloseAllWin			();


