/***************************************************************************************/
/* obj_telop.h                                                I.P.S  v 3.6  15/09/1995 */
/*                                                                                     */
/* gestion de l'objet telop (ico->nat_obj = ICO_TELOP)   Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


#define TELOP_VECM	OPER_VECM

#define LED_SLEEP	0
#define LED_WAIT	1
#define LED_RUN		2
#define LED_RUN_LO	3
#define LED_RUN_HI	37


/* Type Telop */

typedef struct {
	int		led_pourcent,		/* LED_SLEEP, LED_RUN, ..		*/
			nb_image_in,		/* nb d'images en entree		*/
			nb_image_out,		/* nb d'images en sortie		*/
			same_size,		/* booleen: meme taille des images	*/
			val_cadre,		/* -1 : qcq!=0 ; x>=0 : cadre a x	*/
			mot_x,			/* largeur max des sous-titres		*/
			attach_n, *attach_v,	/* nb attach, vecteur des nums des icos	*/
			ctx,			/* num du contexte, -1 si aucun		*/
                        param_nb,		/* nb de params				*/
                        *param_type;		/* vecteur des types des parametres	*/
	void            **param_adr;		/* vecteur des adresses des parametres	*/
	char		*titre,			/* titre de telop			*/
                        *idf,			/* identificateur lu dans ressource	*/
                        *nomf,			/* nom complet de l'executable		*/
                        *nom_host,		/* nom de la machine distante		*/
                        *nom_aide,		/* nom complet du fichier d'aide	*/
			**lgd_images;		/* Legendes pr les images en in,out	*/
	Frame		frame_parbox;		/* Frame de la boite de dialogue 	*/
	Fig_data	*fig;			/* Fig windows eventuelles, cf figw.c	*/
	} Telop;


/* Types de parametres pour les telops */

typedef struct {
	char		*legende;		/* Legende du parametre			*/
	int		inf, sup,		/* Borne inf et sup du parametre	*/
			defaut, valeur;		/* Valeur par defaut et choisie		*/
	} Telop_par_int;

typedef struct {
	char		*legende;		/* Legende du parametre			*/
	double		inf, sup,		/* Borne inf et sup du parametre	*/
			defaut, valeur;		/* Valeur par defaut et choisie		*/
	} Telop_par_real;

typedef struct {
	char		*legende,		/* Legende du parametre			*/
			*defaut, *valeur;	/* Texte par defaut et choisi		*/
	int		taille_max;		/* Taille max du string valeur		*/
	} Telop_par_text;

typedef struct {
        char            *legende,               /* Legende du parametre			*/
			**choices;		/* Noms des choix uniques		*/
	int		nchoice,		/* Nombre de choix			*/
			defaut, valeur;		/* Bouton par defaut et choisi		*/
        } Telop_par_choice;


/* Type pour le client_data des parbox */

typedef struct {
	Ico		*ico;			/* Adresse de l'icone			*/
	Telop		*telop;			/* Adresse de telop			*/
	int		*adr;			/* Adresses des champs de saisie	*/
	} Telop_parbox;

/* Type pour chaussette.c ; n'est stocke' que pendant un Run */

typedef struct {			/* struct pour cs_set_data2 de chaussette.c 	*/
	int	nb,			/* icones data selectionne's 			*/
		n1, n2,			/* nb icones IN, IN+OUT 			*/
		cmin;			/* val cadre 					*/
	Ico	*v[TELOP_VECM];		/* v[0] = ico telop ; v[i] = ico image i 	*/
	} Telop_data_cs;


extern void		 telop_init				();
extern void		 telop_free 				();
extern void		 telop_duplic				();
extern void		 telop_affi_ico				();
extern void		 telop_prepare_noms			();
extern void		 telop_decode_def			();
extern void		 telop_decode_cho			();
extern void		 telop_encode_cho			(); 
extern int		 telop_retrouve_selec			();
extern int		 telop_check_run			();
extern void		 telop_encode_dim			();
extern int		 telop_decode_dim			();
extern void		 telop_parbox_creat			();
extern int		 telop_parbox_butt_panel_proc		();
extern void		 telop_parbox_butt_menu_proc		();
extern void		 telop_parbox_butt_direct		();
extern void		 telop_parbox_par_choice_proc		();
extern void		 telop_parbox_kill			();
extern int		 telop_attach				();
extern void		 telop_detach				();
extern Panel_item	 telop_FramePcpButtCreat		();
extern void		 telop_FramePcpMenuProc			();
extern void		 telop_CloseAllWin			();
extern void		 telop_maj_inout			();
extern void		 telop_change_led			();
extern void		 telop_stop				();


