/***************************************************************************************/
/* obj_vor2d.h                                                I.P.S  v 3.2  3/2/1994   */
/*                                                                                     */
/* gestion de l'objet vor2d  (ico->nat_obj = ICO_VOR2D)  Edouard.Thiel@lim.univ-mrs.fr */
/***************************************************************************************/


#define VOR2D_CH1LEN	63
#define VOR2D_CH2LEN	15

/* Germes de Delaunay */

typedef struct {
	double		point[2];			/* coordonnees x,y du germe	*/
	short		boolean,			/* utilite ?			*/
			num_s;				/* indice d'un sommet voisin	*/
	void		*client_data;			/* donnee du client		*/
	} Vor2d_point, *Vor2d_pt_point;

/* Sommets de Voronoi */

typedef struct {
	double		point[2];			/* coordonnees x,y du sommet	*/
	short		num_gc[3],			/* indices germes createurs	*/
			num_sv[3];			/* indices sommets voisins	*/
	void		*client_data;			/* donnee du client		*/
	} Vor2d_sommet, *Vor2d_pt_sommet;

/* Type Vor2d */

typedef struct {
	short		nb_point,  nb_max_point,	/* taille vecteur tab_point	*/
			nb_sommet, nb_max_sommet;	/* taille vecteur tab_sommet	*/
	Vor2d_point	*tab_point,  *tab_point_base;	/* tab_point  = _base + 3	*/
	Vor2d_sommet	*tab_sommet, *tab_sommet_base;	/* tab_sommet = _base + 4	*/

	char		ch1[VOR2D_CH1LEN+1],		/* titre du vor2d		*/
			ch2[VOR2D_CH2LEN+1],		/* "n.index_creat"		*/
			ch3[VOR2D_CH2LEN+1],		/* nb points Delaunay en vert	*/
			ch4[VOR2D_CH2LEN+1];		/* nb sommets Voronoi en rouge	*/
	int		s_ch1, s_ch2, s_ch3, s_ch4,	/* tailles affichables		*/
			x_ch4;				/* coord x de ch4		*/
	} Vor2d;


extern void		vor2d_creat		();
extern void		vor2d_creat_point	();
extern void		vor2d_creat_sommet	();
extern void		vor2d_adapt_tab_point	();
extern void		vor2d_adapt_tab_sommet	();
extern void		vor2d_free		();
extern void		vor2d_duplic		();
extern void		vor2d_affi_ico		();
extern void		vor2d_prepare_noms	();
extern void		vor2d_CloseAllWin	();
